package dbridge;

import java.io.*;

import com.pixelmed.dicom.*;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class DbDicomCopy
{
    public static void main(String[] args)
    {
        if (args.length < 3)
        {
            return;
        }
        try
        {
System.out.close();
System.err.close();
            //
            // 1. read params
            //
            String sTmpDir = args[0];
            String sFileName = args[1];
            String sAeTitle = args[2];
            //
            // 2. Read studyId
            //
            String sOldFile = sTmpDir;
            sOldFile += File.separator;
            sOldFile += sFileName;

            AttributeList list = new AttributeList();
            InputStream is = new FileInputStream(sOldFile);
            list.read(new DicomInputStream(is), TagFromName.SeriesInstanceUID);
            is.close();
            // Read required data from dicom file
            String sStudyUid = Attribute.getSingleStringValueOrDefault(list,
                    TagFromName.StudyInstanceUID, "");
            //
            // Move file to new place
            //
            String sNewDir = sTmpDir;
            sNewDir += File.separator;
            sNewDir += sAeTitle;
            sNewDir += File.separator;
            sNewDir += "Loc";
            sNewDir += File.separator;
            sNewDir += sStudyUid;
            sNewDir += File.separator;
            String sNewFile = sNewDir + sFileName;

            (new File(sNewDir)).mkdirs();
            MoveFile(sOldFile, sNewFile);
        }
        catch (Exception e)
        {
            // shit happens
        }
    }

    public static void MoveFile(String sOld, String sNew)
    {
        File fNew = new File(sNew);
        File fOld = new File(sOld);
        if (!fOld.renameTo(fNew))
        {
            fNew.delete();
            fOld.renameTo(fNew);
        }
    }
}
