package dbridge;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author Aleh
 * @version 1.0
 */

public class Frame1 extends JFrame {
  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();

  //Construct the frame
  public Frame1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    setIconImage(Toolkit.getDefaultToolkit().getImage(DBConsts.WINDOW_ICON_FILENAME));
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame1.class.getResource("./lib/res/dbridge_client.gif")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);
    //this.setSize(new Dimension(400, 300));//30, 170));//400, 300
    String title="DBridge"+DBridgeClient.Bank().getVersion();
    this.setTitle(title);
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      //JOptionPane msgbox=new JOptionPane();
      Locale currentLocale = BridgeApp.getCurrentLocale();
      ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.DoorLabelsBundle",currentLocale);
      String message = labels.getString("TryToClose");

      JOptionPane.showMessageDialog(this, message);
      this.setVisible(true);
    }
  }

}
