package dbridge;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.border.*;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author aITLab
 * @version 1.0
 */

public class XPop_ImapDlg extends JDialog {

  private dbMailRecord mMailRecord = null;
  boolean mOk = false;
  private ResourceBundle lbls = null;

  final private int coefMIN = 1;
  final private int coefHOURS = 60;
  final private int coefDAYS = 1440;

  final private int cbMIN = 0;
  final private int cbHOURS = 1;
  final private int cbDAYS = 2;

  private ServerField jtfIP = new ServerField();
  private JPasswordField jtfPass = new JPasswordField();
  private JPasswordField jtfConfirm = new JPasswordField();
  private EmailField jtfLogin = new EmailField();
  private JTextArea jTextArea1 = new JTextArea();
  private JCheckBox jcbSSL = new JCheckBox();
  private JTextField jtfTimeout = new JTextField();
  private JTextField jtfPort = new JTextField();
  private JComboBox jcbType = new JComboBox();
  private JComboBox jcbUnits = new JComboBox();

  private JButton jbOk = new JButton();
  private JButton jbCancel = new JButton();
  //------------------------------------------------------------------------

  public XPop_ImapDlg(Dialog parent, String title, boolean modal) {
  super(parent, title, modal);
    mMailRecord=new dbMailRecord("","","","",10);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public XPop_ImapDlg(Frame parent, String title, boolean modal) {
  super(parent, title, modal);
    mMailRecord=new dbMailRecord("","","","",10);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //------------------------------------------------------------------------------
   private void jbInit() throws Exception {

     Locale currentLocale = BridgeApp.getCurrentLocale();
     lbls = ResourceBundle.getBundle("dbridge.prop.XPop_ImapDlgBundle",
                                     currentLocale);

     this.setSize(new Dimension(450, 370));
     this.setMinimumSize(new Dimension(450, 370));
     this.setPreferredSize(new Dimension(450, 370));
     this.setTitle(lbls.getString("title"));


     //-------------- Create local GUI objects -------------------------
     JPanel jPanel1 = new JPanel();
     Box box1;
     FlowLayout flowLayout1 = new FlowLayout();

     JLabel jLabel1 = new JLabel();
     JPanel jPanel2 = new JPanel();
     FlowLayout flowLayout2 = new FlowLayout();

     JLabel jLabel2 = new JLabel();
     JPanel jPanel3 = new JPanel();
     FlowLayout flowLayout3 = new FlowLayout();

     JLabel jLabel3 = new JLabel();
     JPanel jPanel4 = new JPanel();
     JPanel jPanel5 = new JPanel();

     JPanel jPanel6 = new JPanel();
     FlowLayout flowLayout4 = new FlowLayout();

     BorderLayout borderLayout1 = new BorderLayout();
     BorderLayout borderLayout2 = new BorderLayout();
     BorderLayout borderLayout3 = new BorderLayout();
     JPanel jPanel7 = new JPanel();
     FlowLayout flowLayout5 = new FlowLayout();

     JLabel jLabel5 = new JLabel();
     JPanel jPanel8 = new JPanel();
     FlowLayout flowLayout6 = new FlowLayout();
     JLabel jLabel6 = new JLabel();
     TitledBorder titledBorder1;
     TitledBorder titledBorder2;
     TitledBorder titledBorder3;
     TitledBorder titledBorder4;
     JScrollPane jScrollPane1 = new JScrollPane();

     JPanel jPanel9 = new JPanel();
     FlowLayout flowLayout7 = new FlowLayout();
     JLabel jLabel4 = new JLabel();

     JPanel jPanel10 = new JPanel();
     JLabel jLabel7 = new JLabel();
     FlowLayout flowLayout8 = new FlowLayout();
     JPanel jPanel11 = new JPanel();
     FlowLayout flowLayout9 = new FlowLayout();


     this.getContentPane().setLayout(borderLayout1);

    box1 = Box.createVerticalBox();

    titledBorder1 = BorderFactory.createTitledBorder(lbls.getString("serv_par"));

    titledBorder2 = BorderFactory.createTitledBorder(lbls.getString("comments"));
    titledBorder3 = BorderFactory.createTitledBorder(lbls.getString("comments"));
    titledBorder4 = new TitledBorder("");

    jPanel1.setBorder(titledBorder1);
    jPanel1.setLayout(borderLayout2);
    jtfIP.setMinimumSize(new Dimension(200, 25));
    jtfIP.setPreferredSize(new Dimension(200, 25));
    jtfIP.setBounds(new Rectangle(103, 27, 63, 21));

    jLabel1.setMaximumSize(new Dimension(120, 17));
    jLabel1.setMinimumSize(new Dimension(120, 17));
    jLabel1.setPreferredSize(new Dimension(120, 17));
    jLabel1.setText(lbls.getString("name"));
    jLabel1.setBounds(new Rectangle(22, 23, 41, 17));
    jPanel2.setLayout(flowLayout1);
    jtfPass.setBounds(new Rectangle(103, 27, 63, 21));
    jtfPass.setPreferredSize(new Dimension(200, 25));
    jtfPass.setMinimumSize(new Dimension(200, 25));
    jLabel2.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel2.setMaximumSize(new Dimension(120, 17));
    jLabel2.setMinimumSize(new Dimension(120, 17));
    jLabel2.setPreferredSize(new Dimension(120, 17));
    jLabel2.setText(lbls.getString("password"));
    jPanel3.setLayout(flowLayout2);
    jtfLogin.setBounds(new Rectangle(103, 27, 63, 21));

    jtfLogin.setPreferredSize(new Dimension(200, 25));
    jtfLogin.setMinimumSize(new Dimension(200, 25));
    jLabel3.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel3.setMaximumSize(new Dimension(120, 17));
    jLabel3.setMinimumSize(new Dimension(120, 17));
    jLabel3.setPreferredSize(new Dimension(120, 17));
    jLabel3.setText(lbls.getString("username"));
    jPanel4.setLayout(flowLayout3);
    flowLayout1.setVgap(0);
    flowLayout3.setVgap(0);
    flowLayout2.setVgap(0);
    jPanel5.setBorder(titledBorder2);
    jPanel5.setLayout(borderLayout3);
    jTextArea1.setBorder(BorderFactory.createLoweredBevelBorder());
    jTextArea1.setText("");
    jPanel6.setBorder(titledBorder4);
    jPanel6.setLayout(flowLayout4);
    jbOk.setText(lbls.getString("bOk"));
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });
    jbCancel.setText(lbls.getString("bCancel"));
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });
    jPanel7.setLayout(flowLayout5);
    flowLayout5.setVgap(0);
    jtfConfirm.setBounds(new Rectangle(103, 27, 63, 21));
    jtfConfirm.setPreferredSize(new Dimension(200, 25));
    jtfConfirm.setMinimumSize(new Dimension(200, 25));
    jLabel5.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel5.setMaximumSize(new Dimension(120, 17));
    jLabel5.setMinimumSize(new Dimension(120, 17));
    jLabel5.setPreferredSize(new Dimension(120, 17));
    jLabel5.setText(lbls.getString("confirm"));
    jPanel8.setLayout(flowLayout6);
    flowLayout6.setVgap(0);
    jLabel6.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel6.setMaximumSize(new Dimension(120, 17));
    jLabel6.setMinimumSize(new Dimension(120, 17));
    jLabel6.setPreferredSize(new Dimension(120, 17));
    jLabel6.setText(lbls.getString("type"));
    borderLayout3.setHgap(5);
    borderLayout3.setVgap(5);
    borderLayout1.setHgap(10);
    jcbType.setMaximumSize(new Dimension(200, 25));
    jcbType.setMinimumSize(new Dimension(200, 25));
    jcbType.setPreferredSize(new Dimension(200, 25));
    jcbType.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jcbType_actionPerformed(e);
      }
    });
    jPanel9.setLayout(flowLayout7);
    flowLayout7.setVgap(0);
    jLabel4.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel4.setMaximumSize(new Dimension(120, 17));
    jLabel4.setMinimumSize(new Dimension(120, 17));
    jLabel4.setPreferredSize(new Dimension(120, 17));
    jLabel4.setText(lbls.getString("timeout"));
    //jtfTimeout.setBounds(new Rectangle(103, 27, 63, 21));
    jtfTimeout.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jtfTimeout_actionPerformed(e);
      }
    });

    Box box_timeout = Box.createHorizontalBox();
    box_timeout.setPreferredSize(new Dimension(200, 25));
    box_timeout.setMinimumSize(new Dimension(200, 25));
    box_timeout.add(jtfTimeout);
    box_timeout.add(jcbUnits);
    jtfTimeout.setText("10");



    jtfPort.setMinimumSize(new Dimension(200, 25));
    jtfPort.setText("993");
    jtfPort.setPreferredSize(new Dimension(200, 25));
    jtfPort.setBounds(new Rectangle(103, 27, 63, 21));
    jPanel10.setLayout(flowLayout8);
    jLabel7.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel7.setMaximumSize(new Dimension(120, 17));
    jLabel7.setMinimumSize(new Dimension(120, 17));
    jLabel7.setPreferredSize(new Dimension(120, 17));
    jLabel7.setText(lbls.getString("port"));
    flowLayout8.setVgap(0);
    jPanel11.setLayout(flowLayout9);
    flowLayout9.setVgap(0);
    jcbSSL.setMaximumSize(new Dimension(325, 25));
    jcbSSL.setMinimumSize(new Dimension(325, 25));
    jcbSSL.setPreferredSize(new Dimension(325, 25));
    jcbSSL.setSelected(true);
    jcbSSL.setText(lbls.getString("SSL_message"));
    jcbSSL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jcbSSL_actionPerformed(e);
      }
    });
    jPanel1.add(box1, BorderLayout.CENTER);

    box1.add(jPanel8, null);
    box1.add(jPanel2, null);
    box1.add(jPanel4, null);


    box1.add(jPanel3, null);
    box1.add(jPanel7, null);
    box1.add(jPanel9, null);
    box1.add(jPanel10, null);
    box1.add(jPanel11, null);
    jPanel11.add(jcbSSL, null);


    jPanel2.add(jLabel1, null);
    jPanel2.add(jtfIP, null);
    jPanel7.add(jLabel5, null);
    jPanel7.add(jtfConfirm, null);

    jPanel4.add(jLabel3, null);
    jPanel4.add(jtfLogin, null);

    jPanel3.add(jLabel2, null);
    jPanel3.add(jtfPass, null);

    this.getContentPane().add(jPanel1, BorderLayout.NORTH);

    this.getContentPane().add(jPanel5, null);
    jPanel5.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextArea1, null);
    this.getContentPane().add(jPanel6,  BorderLayout.SOUTH);
    jPanel6.add(jbOk, null);
    jPanel6.add(jbCancel, null);
    jPanel7.add(jLabel5, null);
    jPanel7.add(jtfConfirm, null);
    jPanel8.add(jLabel6, null);
    jPanel8.add(jcbType, null);
    jPanel10.add(jLabel7, null);
    jPanel10.add(jtfPort, null);

    jcbType.addItem(lbls.getString("pop"));
    jcbType.addItem(lbls.getString("imap"));

    jcbUnits.addItem(lbls.getString("min"));
    jcbUnits.addItem(lbls.getString("hours"));
    jcbUnits.addItem(lbls.getString("days"));
    jcbUnits.setMinimumSize(new Dimension(100, 0));
    jcbUnits.setPreferredSize(new Dimension(100, 0));

    jPanel9.add(jLabel4, null);
    jPanel9.add(box_timeout, null);


  }

 //-------------------------------------------------------------------------
  public void setFields(dbMailRecord obj){
      if (obj != null){
      this.mMailRecord = obj;
      this.jtfIP.setText(this.mMailRecord.getDomain());
      this.jtfLogin.setText(this.mMailRecord.getMail());
      this.jtfPass.setText(this.mMailRecord.getPassword());
      this.jtfConfirm.setText(this.mMailRecord.getPassword());
      this.jTextArea1.setText(this.mMailRecord.getComments());
      //this.jtfTimeout.setText(Integer.toString((int)obj.getTimeDelay()));
      setTimeoutGUI((int)obj.getTimeDelay());
      if (this.mMailRecord.isPop3()) this.jcbType.setSelectedIndex(0);
      else this.jcbType.setSelectedIndex(1);
      if (this.mMailRecord.isSSL()) this.jcbSSL.setSelected(true);
      else this.jcbSSL.setSelected(false);

      this.jtfPort.setText(Integer.toString(this.mMailRecord.getPort()));
     }
  }
 //--------------------------------------------------------------------------
  public dbMailRecord getFields(){

      return this.mMailRecord;

  }
 //--------------------------------------------------------------------------
  private void fillFields(){

    this.mMailRecord.setDomain(this.jtfIP.getText());
    this.mMailRecord.setMail(this.jtfLogin.getText());
    this.mMailRecord.setComments(this.jTextArea1.getText());
    this.mMailRecord.setPassword(new String (this.jtfPass.getPassword()));
    this.mMailRecord.setTimeDelay(calcTimeout());

    switch (this.jcbType.getSelectedIndex()){
      case 0:
          this.mMailRecord.setToPop3(Integer.parseInt(this.jtfPort.getText()));
           break;
      case 1:
          this.mMailRecord.setToImap(Integer.parseInt(this.jtfPort.getText()));
          break;
    }

    if (this.jcbSSL.isSelected())
      this.mMailRecord.setToSSL(Integer.parseInt(this.jtfPort.getText()));

  }
  //------------------------------------------------------------------------
 void jcbType_actionPerformed(ActionEvent e) {
      this.chkPort();
  }
 //----------------------------------------------------------------------
 void jcbSSL_actionPerformed(ActionEvent e) {
      this.chkPort();
  }
 //-----------------------------------------------------------------------
 private void chkPort(){
    switch (this.jcbType.getSelectedIndex()){
      case 0:
        if (this.jcbSSL.isSelected()) this.jtfPort.setText("995");
        else this.jtfPort.setText("110");
        break;
      case 1:
        if (this.jcbSSL.isSelected()) this.jtfPort.setText("993");
        else this.jtfPort.setText("143");
        break;
    }
 }

 //-----------------------------------------------------------------------
 private int calcTimeout(){
   int result = Integer.valueOf(jtfTimeout.getText()).intValue();
   int coeff = 1;
   switch (this.jcbUnits.getSelectedIndex()){
  case cbMIN:
       coeff = coefMIN;
       break;
  case cbHOURS:
      coeff = coefHOURS;
      break;
  case cbDAYS:
        coeff = coefDAYS;
        break;

}
    result *= coeff;
   return result;
 }
 //----------------------------------------------------------------------
 private void setTimeoutGUI(int timeout){
   int timeout_units = 0;
   int cbUnits_index = 0;
   if (timeout>coefDAYS){
     timeout_units = timeout/coefDAYS;
     cbUnits_index = cbDAYS;
   }else if (timeout>coefHOURS){
     timeout_units = timeout/coefHOURS;
     cbUnits_index = cbHOURS;
   }else{
     timeout_units = timeout;
     cbUnits_index = cbMIN;
   }
   jcbUnits.setSelectedIndex(cbUnits_index);
   jtfTimeout.setText(Integer.toString(timeout_units));
 }


 //-----------------------------------------------------------------------
  public boolean isOk(){
    return mOk;
  }
 //--------------------------------------------------------------------------

  void jbOk_actionPerformed(ActionEvent e) {
    if (!chkErrors()) return;

    this.fillFields();
    this.mOk = true;
    this.setVisible(false);
  }
//---------------------------------------------------------------------------
  void jbCancel_actionPerformed(ActionEvent e) {
    this.mOk = false;
    this.setVisible(false);
  }
  //------------------------------------------------------------------------
  boolean chkErrors (){
    if (jtfIP.getText().length()<1){
      JOptionPane.showMessageDialog(this, lbls.getString("serv_err"),
                                   lbls.getString("pop_imap"),
                                   JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (jtfLogin.getText().length()<1){
      JOptionPane.showMessageDialog(this, lbls.getString("user_err"),
                                    lbls.getString("pop_imap"),
                                    JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (this.jtfTimeout.getText().length()<1){
      JOptionPane.showMessageDialog(this,lbls.getString("timeout_err"),
                                    lbls.getString("pop_imap"),
                                    JOptionPane.QUESTION_MESSAGE);
      return false;
    }


    //TODO perhaps need to change new String ...
    if ((new String (jtfPass.getPassword())).
        compareTo(new String (jtfConfirm.getPassword()))!=0){
         JOptionPane.showMessageDialog(this,
         lbls.getString("password_err"),
          lbls.getString("pop_imap"), JOptionPane.WARNING_MESSAGE);
         return false; }

    return true;
  }
//------------------------------------------------------------------------------

//================= DEBUG -----------------------
   public static void main(String[] args) {
    XPop_ImapDlg XPop_ImapRecordDlg1 = new XPop_ImapDlg((Frame) null, "111", true);
    XPop_ImapRecordDlg1.setVisible(true);
  }

  void jtfTimeout_actionPerformed(ActionEvent e) {

  }

//-------------------------------------------------------------------------
}
