package dbridge;

import java.util.*;
import java.io.File;

import javax.swing.JOptionPane;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 */

 /*
 * Created: 24.09.07
 */

 // The goal of this class is to realize simple instance of application though using lock data.

 public class dbLock {
	 dbLock(String filename){
		 m_fileName=filename;
		 m_lockText="Locked";
  };

  /**
   * 
   * @return true if the loch file exists
   */
  public boolean isLocked(){
	  boolean res = (new File(m_fileName)).exists();
	  return res;
  }
  /**
   * 
   * @return true if the lock file was deleted
   */
  public boolean deleteLock(){
	   boolean res = (new File(m_fileName)).delete();
	    if (!res) {
	        // Deletion failed
	    	JOptionPane.showMessageDialog(null, "Deletion of the loch file "+ m_fileName+" failed");
	    }
	  return res;
  }
  
  /**
   * 
   * @return true, if the file was created and false if the file exists
   */
  public boolean setLock(){
	  boolean res=false;
	  try {
	        File file = new File(m_fileName);
	        // Create file if it does not exist
	        res = file.createNewFile();
	        if ( !res ){
	        	JOptionPane.showMessageDialog(null, m_lockText);
	        }
	    } catch (Exception e) {
	    	System.out.println("Exception: "+e.getMessage());
	    }
	  return res;
  }
  
  public void setLockText(String txt){
	  m_lockText=txt;
  }
  

  private String m_lockText;
  private String m_fileName;

//DEBUG and used to delete deadlocks //
  public static void main(String[] args) {
     dbLock lockServer=new dbLock(".servlock");
     //lockapp.setLockText("");
     //lockapp.setLock();
    
     //if ( lockapp.isLocked() ) JOptionPane.showMessageDialog(null, "Lock correct");
     //else JOptionPane.showMessageDialog(null, "Lock wrong");
     
     if ( lockServer.deleteLock() ) JOptionPane.showMessageDialog(null, "DBridge Server Lock deleted");
     else  JOptionPane.showMessageDialog(null, "DBridge Server Lock cannot be deleted");
     
     dbLock lockClient=new dbLock(".clilock");
     if ( lockClient.deleteLock() ) JOptionPane.showMessageDialog(null, "DBridge Client Lock deleted");
     else  JOptionPane.showMessageDialog(null, "DBridge Client Lock cannot be deleted");
     
  }
}
