package dbridge;

import java.util.*;
import java.io.*;
/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

// 11.12.2004 changed BOB
//
//

public class dbMailTable implements java.io.Serializable {
  Vector v;
  public dbMailTable() {
    v=new Vector();
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  public dbMailTable(dbMailTable obj) {
    v=new Vector(obj.v);
  }
  public void append(dbMailRecord obj) { // add an item to the end
    v.add(obj);
  }

  //added by BOB
  public void setElementAt(dbMailRecord obj, int pos){
    v.setElementAt(obj, pos);
  }

  public void delete(int key) { // remove the key-th item
    if ( isIndex(key) )
      v.removeElementAt(key); //.removeElementAt(new Integer(key));
  }
  public void deleteLast() { // remove the last item
    v.removeElementAt(v.size()-1);
  }

  public void deleteEllement(dbMailRecord obj){
    v.remove(obj);
  }

  public int getSize(){ return v.size();}

  public dbMailRecord getRecord(int key){
    if ( isIndex(key) ) return (dbMailRecord)v.get(key);
    else return null;
  }

  public Vector getList(){  // return a list of all e-mails or null
    Vector list=new Vector();
    for (int i=0; i<v.size(); i++){
      list.add(((dbMailRecord)v.get(i)).getMailDomainAddr());
    }
    return list;
  }

  public Vector getVectorCopy(){
    Vector result = new Vector(v);
    return result;
  }

  //
  // Added by BOB.
  // For GUI no reason to get a copy (tormozit toka budit:-)

  public Vector getVectorPtr(){
    return v;
  }

  public boolean isIndex(int i){
    if ( i>=0 && i<v.size() ) return true;
    else return false;
  }
  // DEBUG
  public void print() {
    System.out.println("Table size " + v.size());
    for ( int i=0; i<v.size(); i++ ){
      System.out.println("############ record " + i +" ###########");
      dbMailRecord obj=(dbMailRecord)v.get(i);
      if ( obj!=null ) obj.print();
    }
  }// end print

  public static void main(String[] args) {
    System.out.println("Test table");
    dbMailTable obj = new dbMailTable();
    obj.append(new dbMailRecord("aaa@de","first","passwd1",1));
    obj.append(new dbMailRecord("aab@de","","passwd2",1));
    obj.append(new dbMailRecord("aba@de","third","passwd3",1));
    obj.append(new dbMailRecord("abb@de","fourth","passwd4",1));
    obj.append(new dbMailRecord("baa@de","fives","passwd5",1));
    obj.print();
    obj.delete(3);
    obj.deleteLast();
    obj.print();
    // save in file
    try {
       FileOutputStream file = new FileOutputStream("mailtable.ser");
       ObjectOutputStream oFile=new ObjectOutputStream(file);

          oFile.writeObject(obj);
          oFile.flush();
      oFile.close();
    }
    catch(Exception e){System.err.println(e);}
    //resd object
    try {
       FileInputStream file = new FileInputStream("mailtable.ser");
       ObjectInputStream iFile=new ObjectInputStream(file);
        System.out.println("Data from file");
          try{
            dbMailTable obj2=(dbMailTable)iFile.readObject();
            obj2.print();
          } catch(IOException ioe){
            iFile.close();
            System.out.println("End of file reached");
          }// end catch
    } catch(Exception e){System.err.println(e);}
  }

  private void jbInit() throws Exception {
  }

}
