package dbridge;

import java.util.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

public class dbUserPanel extends JDialog{
  // Data to be entered
  dbUser mUser;
  dbUser mUser_ref = null;

  //EncryptDecryptGPGWrapper
//24.08  GpgWrapper mWrapper= null;  // IMPORTANT to inizialize this field  ToDO: remove this line
  dbBank mBank=null;                               // IMPORTANT to inizialize this field
  boolean mOk=false;
  boolean bName_entered = false;
  boolean bEdit_mode = false;

 // GUI components;
  JPanel contentPane;
  JPanel jPanel_username = new JPanel();
  JPanel jPanel_addr = new JPanel();
  JPanel jPanel_buttons = new JPanel();
  JPanel jPanel_LEFT = new JPanel();
  JPanel jPanel_RIGHT = new JPanel();
  JButton jbPOP_New = new JButton();
  JLabel jServerLbl = new JLabel();
  JButton jbPOP_Edit = new JButton();
  JButton jbPOP_Delete = new JButton();
  JScrollPane jServerPane1 = new JScrollPane();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JPanel jPanel5 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout5 = new BorderLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  JPanel jPanel6 = new JPanel();
  JPanel jPanel7 = new JPanel();
  JPanel jPanel8 = new JPanel();
  FlowLayout flowLayout3 = new FlowLayout();
  BorderLayout borderLayout6 = new BorderLayout();
  FlowLayout flowLayout4 = new FlowLayout();
  JLabel jADDRLbl = new JLabel();
  JScrollPane jAddrPane1 = new JScrollPane();
  JButton jbAB_New = new JButton();
  JButton jbAB_Delete = new JButton();
  JButton jbAB_Edit = new JButton();
  BorderLayout borderLayout7 = new BorderLayout();
  JButton jOkBttn = new JButton();
  JButton jCancelBttn = new JButton();
  FlowLayout flowLayout5 = new FlowLayout();
  //-------------------------------------------------------
  Vector mList1=new Vector();   // list of e-mails in the user's mail table
  Vector mList2=new Vector();   // list of e-mails in the address book
  Vector mList3=new Vector();   // list of SMTP servers

  JList jServerList1 = new JList();
  JList jSMTPList1 = new JList();
  JList jAddrList1 = new JList();

  JScrollPane jAddrPane2 = new JScrollPane();
  JLabel jADDRLbl1 = new JLabel();
  JPanel jPanel_CENTER = new JPanel();
  BorderLayout borderLayout8 = new BorderLayout();
  BorderLayout borderLayout10 = new BorderLayout();
  JButton jbSMTP_Delete = new JButton();
  JButton jbSMTP_Edit = new JButton();
  FlowLayout flowLayout6 = new FlowLayout();
  FlowLayout flowLayout7 = new FlowLayout();
  JButton jbSMTP_New = new JButton();
  JPanel jPanel9 = new JPanel();
  JPanel jPanel10 = new JPanel();
  JPanel jPanel11 = new JPanel();
  Box box1;
  BorderLayout borderLayout11 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JLabel jlLogin = new JLabel();
  JTextField jtfLogin = new JTextField();
  FlowLayout flowLayout8 = new FlowLayout();
  Box box2;
  JPanel jPanel12 = new JPanel();
  JTextField jtfConfirm = new JPasswordField();
  JLabel jlConfirm = new JLabel();
  FlowLayout flowLayout10 = new FlowLayout();
  JTextField jtfPassword = new JPasswordField();
  FlowLayout flowLayout11 = new FlowLayout();
  JLabel jlPass = new JLabel();
  JPanel jPanel13 = new JPanel();
  JTextField jtfName = new JTextField();
  JPanel jPanel2 = new JPanel();
  JLabel jlName = new JLabel();
  FlowLayout flowLayout9 = new FlowLayout();
  JPanel jPanel14 = new JPanel();
  TitledBorder titledBorder1;
  FlowLayout flowLayout12 = new FlowLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel15 = new JPanel();
  TitledBorder titledBorder2;
  JTextField jtfConfirm_decr = new JPasswordField();
  FlowLayout flowLayout13 = new FlowLayout();
  JLabel jlConfirm1 = new JLabel();
  JLabel jlPass1 = new JLabel();
  JPanel jPanel17 = new JPanel();
  JPanel jPanel18 = new JPanel();
  Box box3;
  JTextField jtfPassword_decr = new JPasswordField();
  FlowLayout flowLayout15 = new FlowLayout();
  FlowLayout flowLayout14 = new FlowLayout();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  //----------------------------------------------------------------

  public dbUserPanel(JFrame parent, boolean modal) {
  super(parent, modal);
    mUser=new dbUser();
    mUser.setLogin("");
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    mOk=false;

    box1 = Box.createHorizontalBox();
    box2 = Box.createVerticalBox();
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(new Color(240, 217, 205),new Color(117, 106, 100)),labels.getString("titledBorder1"));
    titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder(new Color(240, 217, 205),new Color(117, 106, 100)),labels.getString("titledBorder2"));
    box3 = Box.createVerticalBox();
    this.setSize(new Dimension(600, 390));
		this.setTitle(labels.getString("title"));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout1);

    contentPane.addAncestorListener(new javax.swing.event.AncestorListener() {
      public void ancestorAdded(AncestorEvent e) {
        this_ancestorAdded(e);
      }
      public void ancestorRemoved(AncestorEvent e) {
      }
      public void ancestorMoved(AncestorEvent e) {
      }
    });

    jPanel_username.setLayout(gridBagLayout1);
    jPanel_addr.setLayout(borderLayout11);
    jPanel_buttons.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel_buttons.setLayout(flowLayout5);
    jPanel_LEFT.setLayout(borderLayout5);
    jPanel_RIGHT.setMinimumSize(new Dimension(187, 130));
    jPanel_RIGHT.setPreferredSize(new Dimension(187, 130));
    jPanel_RIGHT.setLayout(borderLayout7);
    jbPOP_New.setMaximumSize(new Dimension(59, 21));
    jbPOP_New.setMinimumSize(new Dimension(59, 21));
    jbPOP_New.setPreferredSize(new Dimension(59, 21));
    jbPOP_New.setMargin(new Insets(0, 0, 0, 0));
    jbPOP_New.setText(labels.getString("jbNewText"));
    jbPOP_New.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbPOP_New_actionPerformed(e);
      }
    });
    jServerLbl.setText(labels.getString("jServerLblText"));
    jbPOP_Edit.setEnabled(false);
    jbPOP_Edit.setMaximumSize(new Dimension(55, 21));
    jbPOP_Edit.setMinimumSize(new Dimension(55, 21));
    jbPOP_Edit.setPreferredSize(new Dimension(55, 21));
    jbPOP_Edit.setMargin(new Insets(0, 0, 0, 0));
    jbPOP_Edit.setText(labels.getString("jbEditText"));
    jbPOP_Edit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbPOP_Edit_actionPerformed(e);
      }
    });
    jbPOP_Delete.setEnabled(false);
    jbPOP_Delete.setMaximumSize(new Dimension(71, 21));
    jbPOP_Delete.setMinimumSize(new Dimension(71, 21));
    jbPOP_Delete.setPreferredSize(new Dimension(71, 21));
    jbPOP_Delete.setMargin(new Insets(0, 0, 0, 0));
    jbPOP_Delete.setText(labels.getString("jbDeleteText"));
    jbPOP_Delete.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbPOP_Delete_actionPerformed(e);
      }
    });
    jServerPane1.setActionMap(null);
    jServerPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jPanel4.setLayout(borderLayout4);
    jPanel5.setLayout(flowLayout1);
    flowLayout1.setHgap(0);
    flowLayout1.setVgap(0);
    jPanel3.setLayout(flowLayout2);
    flowLayout2.setHgap(3);
    flowLayout2.setVgap(3);
    jPanel6.setLayout(flowLayout3);
    jPanel7.setLayout(borderLayout6);
    jPanel8.setLayout(flowLayout4);
    jADDRLbl.setText(labels.getString("jAddrLblText"));
    flowLayout3.setHgap(3);
    flowLayout3.setVgap(3);
    jAddrPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jAddrPane1.setMinimumSize(new Dimension(24, 54));
    jAddrPane1.setPreferredSize(new Dimension(20, 54));
    flowLayout4.setHgap(0);
    flowLayout4.setVgap(0);
    jbAB_New.setMaximumSize(new Dimension(59, 21));
    jbAB_New.setMinimumSize(new Dimension(59, 21));
    jbAB_New.setPreferredSize(new Dimension(59, 21));
    jbAB_New.setMargin(new Insets(0, 0, 0, 0));
    jbAB_New.setText(labels.getString("jbNewText"));
    jbAB_New.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbAB_New_actionPerformed(e);
      }
    });
    jbAB_Delete.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbAB_Delete_actionPerformed(e);
      }
    });
    jbAB_Delete.setEnabled(false);
    jbAB_Delete.setMaximumSize(new Dimension(71, 21));
    jbAB_Delete.setMinimumSize(new Dimension(71, 21));
    jbAB_Delete.setPreferredSize(new Dimension(71, 21));
    jbAB_Delete.setMargin(new Insets(0, 0, 0, 0));
    jbAB_Delete.setText(labels.getString("jbDeleteText"));
    jbAB_Edit.setEnabled(false);
    jbAB_Edit.setMaximumSize(new Dimension(55, 21));
    jbAB_Edit.setMinimumSize(new Dimension(55, 21));
    jbAB_Edit.setPreferredSize(new Dimension(55, 21));
    jbAB_Edit.setMargin(new Insets(0, 0, 0, 0));
    jbAB_Edit.setText(labels.getString("jbEditText"));
    jbAB_Edit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbAB_Edit_actionPerformed(e);
      }
    });
    jOkBttn.setText(labels.getString("jbApplyText"));
    jOkBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jOkBttn_actionPerformed(e);
      }
    });
    jCancelBttn.setText(labels.getString("jbCancelText"));
    jCancelBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCancelBttn_actionPerformed(e);
      }
    });
    jPanel_username.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel_username.setMaximumSize(new Dimension(2147483647, 300));
    jPanel_username.setMinimumSize(new Dimension(600, 140));
    jPanel_username.setPreferredSize(new Dimension(600, 140));
    jPanel_addr.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel_LEFT.setMinimumSize(new Dimension(187, 130));
    jPanel_LEFT.setPreferredSize(new Dimension(187, 130));
    jAddrPane2.setPreferredSize(new Dimension(20, 54));
    jAddrPane2.setMinimumSize(new Dimension(24, 54));
    jAddrPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jADDRLbl1.setText(labels.getString("jAddrLbl1Text"));
    jPanel_CENTER.setLayout(borderLayout8);
    jPanel_CENTER.setPreferredSize(new Dimension(187, 130));
    jPanel_CENTER.setMinimumSize(new Dimension(187, 130));
    jbSMTP_Delete.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbSMTP_Delete_actionPerformed(e);
      }
    });
    jbSMTP_Delete.setEnabled(false);
    jbSMTP_Delete.setMaximumSize(new Dimension(71, 21));
    jbSMTP_Delete.setMinimumSize(new Dimension(71, 21));
    jbSMTP_Delete.setPreferredSize(new Dimension(71, 21));
    jbSMTP_Delete.setMargin(new Insets(0, 0, 0, 0));
    jbSMTP_Delete.setText(labels.getString("jbDeleteText"));
    jbSMTP_Edit.setEnabled(false);
    jbSMTP_Edit.setMaximumSize(new Dimension(55, 21));
    jbSMTP_Edit.setMinimumSize(new Dimension(55, 21));
    jbSMTP_Edit.setPreferredSize(new Dimension(55, 21));
    jbSMTP_Edit.setMargin(new Insets(0, 0, 0, 0));
    jbSMTP_Edit.setText(labels.getString("jbEditText"));
    jbSMTP_Edit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbSMTP_Edit_actionPerformed(e);
      }
    });
    flowLayout6.setHgap(0);
    flowLayout6.setVgap(0);
    flowLayout7.setHgap(3);
    flowLayout7.setVgap(3);
    jbSMTP_New.setMaximumSize(new Dimension(59, 21));
    jbSMTP_New.setMinimumSize(new Dimension(59, 21));
    jbSMTP_New.setPreferredSize(new Dimension(59, 21));
    jbSMTP_New.setMargin(new Insets(0, 0, 0, 0));
    jbSMTP_New.setText(labels.getString("jbNewText"));
    jbSMTP_New.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbSMTP_New_actionPerformed(e);
      }
    });
    jPanel9.setLayout(flowLayout6);
    jPanel10.setLayout(borderLayout10);
    jPanel11.setLayout(flowLayout7);
    jPanel1.setMaximumSize(new Dimension(257, 26));
    jPanel1.setMinimumSize(new Dimension(257, 26));
    jPanel1.setPreferredSize(new Dimension(257, 26));
    jPanel1.setLayout(flowLayout8);
    //jlLogin.setFont(new java.awt.Font("Dialog", 1, 14));
    jlLogin.setMaximumSize(new Dimension(120, 17));
    jlLogin.setMinimumSize(new Dimension(120, 17));
    jlLogin.setPreferredSize(new Dimension(120, 17));
    jlLogin.setText(labels.getString("login"));
    jtfLogin.setMinimumSize(new Dimension(120, 21));
    jtfLogin.setPreferredSize(new Dimension(120, 21));
    jtfLogin.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        jtfLogin_keyReleased(e);
      }
    });
    flowLayout8.setAlignment(FlowLayout.LEFT);
    flowLayout8.setVgap(1);
    jPanel12.setLayout(flowLayout11);
    jPanel12.setPreferredSize(new Dimension(257, 26));
    jPanel12.setMinimumSize(new Dimension(257, 26));
    jPanel12.setMaximumSize(new Dimension(257, 26));
    jtfConfirm.setMinimumSize(new Dimension(120, 21));
    jtfConfirm.setPreferredSize(new Dimension(120, 21));
    jlConfirm.setMaximumSize(new Dimension(120, 17));
    jlConfirm.setMinimumSize(new Dimension(120, 17));
    jlConfirm.setPreferredSize(new Dimension(120, 17));
    jlConfirm.setText(labels.getString("confirmPass"));
    flowLayout10.setAlignment(FlowLayout.LEFT);
    flowLayout10.setVgap(1);
    jtfPassword.setPreferredSize(new Dimension(120, 21));
    jtfPassword.setMinimumSize(new Dimension(120, 21));
    flowLayout11.setAlignment(FlowLayout.LEFT);
    flowLayout11.setVgap(1);
    jlPass.setMaximumSize(new Dimension(120, 17));
    jlPass.setMinimumSize(new Dimension(120, 17));
    jlPass.setPreferredSize(new Dimension(120, 17));
    jlPass.setText(labels.getString("pass"));
    jPanel13.setLayout(flowLayout10);
    jPanel13.setMaximumSize(new Dimension(257, 26));
    jPanel13.setMinimumSize(new Dimension(257, 26));
    jPanel13.setPreferredSize(new Dimension(257, 26));
    jtfName.setPreferredSize(new Dimension(120, 21));
    jtfName.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyReleased(KeyEvent e) {
        jtfName_keyReleased(e);
      }
    });
    jtfName.setMinimumSize(new Dimension(120, 21));
    jPanel2.setLayout(flowLayout9);
    jPanel2.setPreferredSize(new Dimension(257, 26));
    jPanel2.setMinimumSize(new Dimension(257, 26));
    jPanel2.setMaximumSize(new Dimension(257, 26));
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jlName.setMaximumSize(new Dimension(120, 17));
    jlName.setMinimumSize(new Dimension(120, 17));
    jlName.setPreferredSize(new Dimension(120, 17));
    jlName.setText("User Description:");
    flowLayout9.setAlignment(FlowLayout.LEFT);
    flowLayout9.setVgap(1);
    jPanel14.setBorder(titledBorder1);
    jPanel14.setLayout(flowLayout12);
    jPanel15.setBorder(titledBorder2);
    jPanel15.setLayout(flowLayout14);
    jtfConfirm_decr.setPreferredSize(new Dimension(120, 21));
    jtfConfirm_decr.setMinimumSize(new Dimension(120, 21));
    flowLayout13.setAlignment(FlowLayout.LEFT);
    flowLayout13.setVgap(1);
    jlConfirm1.setMaximumSize(new Dimension(120, 17));
    jlConfirm1.setMinimumSize(new Dimension(120, 17));
    jlConfirm1.setPreferredSize(new Dimension(120, 17));
    jlConfirm1.setText(labels.getString("confirmPass"));
    jlPass1.setMaximumSize(new Dimension(120, 17));
    jlPass1.setMinimumSize(new Dimension(120, 17));
    jlPass1.setPreferredSize(new Dimension(120, 17));
    jlPass1.setText(labels.getString("pass"));
    jPanel17.setLayout(flowLayout13);
    jPanel17.setMaximumSize(new Dimension(257, 26));
    jPanel17.setMinimumSize(new Dimension(257, 26));
    jPanel17.setPreferredSize(new Dimension(257, 26));
    jPanel18.setLayout(flowLayout15);
    jPanel18.setPreferredSize(new Dimension(257, 26));
    jPanel18.setMinimumSize(new Dimension(257, 26));
    jPanel18.setMaximumSize(new Dimension(257, 26));
    jtfPassword_decr.setPreferredSize(new Dimension(120, 21));
    jtfPassword_decr.setMinimumSize(new Dimension(120, 21));
    flowLayout15.setAlignment(FlowLayout.LEFT);
    flowLayout15.setVgap(1);
    flowLayout14.setAlignment(FlowLayout.LEFT);
    flowLayout14.setHgap(0);
    flowLayout14.setVgap(0);
    jPanel_LEFT.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jServerLbl, null);
    jPanel_LEFT.add(jPanel4, BorderLayout.CENTER);
    jPanel4.add(jServerPane1, BorderLayout.CENTER);
    jPanel_LEFT.add(jPanel5, BorderLayout.SOUTH);
    jPanel5.add(jbPOP_New, null);
    jPanel5.add(jbPOP_Edit, null);
    jPanel5.add(jbPOP_Delete, null);
    box1.add(jPanel_RIGHT, null);
    jPanel8.add(jbAB_New, null);
    jPanel8.add(jbAB_Edit, null);
    jPanel8.add(jbAB_Delete, null);
    box1.add(jPanel_CENTER, null);
    jPanel_CENTER.add(jPanel11, BorderLayout.NORTH);
    jPanel11.add(jADDRLbl1, null);
    jPanel_CENTER.add(jPanel10, BorderLayout.CENTER);
    jPanel10.add(jAddrPane2, BorderLayout.CENTER);
    jPanel_CENTER.add(jPanel9, BorderLayout.SOUTH);
    jPanel9.add(jbSMTP_New, null);
    jPanel9.add(jbSMTP_Edit, null);
    jPanel9.add(jbSMTP_Delete, null);
    box1.add(jPanel_LEFT, null);
    jPanel_buttons.add(jOkBttn, null);
    jPanel_buttons.add(jCancelBttn, null);
    contentPane.add(jPanel_username, BorderLayout.NORTH);
    contentPane.add(jPanel_addr, BorderLayout.CENTER);
    jPanel_addr.add(box1, BorderLayout.CENTER);
    jPanel1.add(jlLogin, null);
    jPanel1.add(jtfLogin, null);
    box2.add(jPanel1, null);
    box2.add(jPanel13, null);
    contentPane.add(jPanel_buttons, BorderLayout.SOUTH);
    jPanel_RIGHT.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jADDRLbl, null);
    jPanel_RIGHT.add(jPanel7, BorderLayout.CENTER);
    jPanel7.add(jAddrPane1, BorderLayout.CENTER);
    jPanel_RIGHT.add(jPanel8, BorderLayout.SOUTH);
    jPanel13.add(jlPass, null);
    jPanel13.add(jtfPassword, null);
    box2.add(jPanel12, null);
    jPanel12.add(jlConfirm, null);
    jPanel12.add(jtfConfirm, null);
    jPanel2.add(jlName, null);
    jPanel2.add(jtfName, null);
    jPanel_username.add(jPanel15,  new GridBagConstraints(1, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 18, 53), 0, -2));
    jPanel15.add(box3, null);
    jPanel17.add(jlPass1, null);
    jPanel17.add(jtfPassword_decr, null);

    box3.add(jPanel17, null);
    box3.add(jPanel18, null);

    jPanel18.add(jlConfirm1, null);
    jPanel18.add(jtfConfirm_decr, null);
    jPanel_username.add(jPanel14,  new GridBagConstraints(0, 0, 1, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(4, 4, 18, 0), -10, -3));
    jPanel14.add(box2, null);
    jPanel_username.add(jPanel2,  new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(12, 0, 0, 53), 12, 1));

    //---------------------------------------------
    jServerList1.setListData(mList1);
    jServerList1.setSelectedIndex(0);

    jSMTPList1.setListData(mList3);;
    jSMTPList1.setSelectedIndex(0);

    jAddrList1.setListData(mList2);
    jAddrList1.setSelectedIndex(0);

    jServerPane1.getViewport().setView(jServerList1);
    jServerList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jServerList1.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        jServerList1_keyPressed(e);
      }
    });
    jAddrPane1.getViewport().setView(jAddrList1);
    jAddrList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

     jAddrPane2.getViewport().setView(jSMTPList1);
     jSMTPList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

    //------------------------------------------------------

  }
  
  public void setEditMode(boolean edit){
    bEdit_mode = edit;
    if (bEdit_mode)
    this.jtfLogin.setEditable(false);
    else this.jtfLogin.setEditable(true);
  }

  public void setBank(dbBank bank){
     mBank=bank;
  }

  public dbUser getUser(){
    mUser_ref.copy(mUser);
    return mUser_ref;
  }

  public void setUser(dbUser user){
    mUser = new dbUser (user);
    mUser_ref = user;
    writeFields();
  }

  public boolean isOk(){
    return mOk;
  }

  private void fillFields(){
    mUser.setID(100);  // TODO: set a unique ID
    mUser.setName( jtfName.getText() );
    mUser.setLogin(jtfLogin.getText());
    mUser.setPassword(jtfPassword.getText());
    mUser.setDecryptPwd(jtfPassword_decr.getText());

    int sel = this.jSMTPList1.getSelectedIndex();
    mUser.getSmtpTable().setDefaultN(sel);

  }


  private void writeFields(){

    jtfName.setText(mUser.getName());
    jtfLogin.setText(mUser.getLogin());
    jtfPassword.setText(mUser.getPassword());
    jtfConfirm.setText(mUser.getPassword());

    jtfPassword_decr.setText(mUser.getDecryptPwd());
    jtfConfirm_decr.setText(mUser.getDecryptPwd());

    mList1=mUser.getMailTable().getList();
    mList2=mUser.getAddressBook().getList();
    mList3=mUser.getSmtpTable().getList();

    jServerList1.setListData(mList1);  // update list1
    jServerList1.setSelectedIndex(0);

    if (mList1.size()>0){
      this.jbAB_Edit.setEnabled(true);
      this.jbAB_Delete.setEnabled(true);
    }

    jAddrList1.setListData(mList2);  // update list1
    jAddrList1.setSelectedIndex(0);

    if (mList2.size()>0){
      this.jbPOP_Edit.setEnabled(true);
      this.jbPOP_Delete.setEnabled(true);
    }

    jSMTPList1.setListData(mList3);
    jSMTPList1.setSelectedIndex(0);

    if (mList2.size()>0){
      this.jbSMTP_Edit.setEnabled(true);
      this.jbSMTP_Delete.setEnabled(true);
    }

    if (jtfName.getText().length()>0) bName_entered = true;
    else bName_entered = false;

  }

  void jbPOP_New_actionPerformed(ActionEvent e) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

     XPop_ImapDlg obj=new XPop_ImapDlg(this,labels.getString("popImapDlgTitle"),true);

     this.setVisible(false);
     obj.setVisible(true);  // call dialog

    if (obj.isOk()){
         dbMailRecord data=new dbMailRecord();
         System.out.println("Read fields");
         data=obj.getFields();
         if ( data!=null ) {
            // add server into email-list
            //System.out.println("New Addres is "+data.getMailDomainAddr());
            mList1.add(data.getMailDomainAddr());
            jServerList1.setListData(mList1);
            jServerList1.setSelectedIndex(0);
            mUser.appendToTable(data);

            this.jbPOP_Edit.setEnabled(true);
            this.jbPOP_Delete.setEnabled(true);
         }
      }
     this.setVisible(true);
  }

  void jbPOP_Delete_actionPerformed(ActionEvent e) {

     int selection=jServerList1.getSelectedIndex();  // get index
     mList1.removeElementAt( selection ); // remove the selection from the vector
     jServerList1.setListData( mList1 ); // update the list
     mUser.getMailTable().delete(selection);

     if (mList1.size()<1){
      this.jbPOP_Edit.setEnabled(false);
      this.jbPOP_Delete.setEnabled(false);
     }
  }

  void jOkBttn_actionPerformed(ActionEvent e) {

    // Verify errors
    if (!this.checkErrors()) return;
    fillFields();
    // set ok flag
    mOk=true;
    //System.out.println("OK BUTTON is ok");
    // close panel
    //mParent.dispose();
    this.setVisible(false);
  }

  void jCancelBttn_actionPerformed(ActionEvent e) {
    // set ok flag
    mOk=false;
    // close planel
    //mParent.dispose();
    this.setVisible(false);
  }

  void jServerList1_keyPressed(KeyEvent e) {

  }

  void jAddrList1_keyPressed(KeyEvent e) {

  }

  void this_ancestorAdded(AncestorEvent e) {

  }

  void jbAB_New_actionPerformed(ActionEvent e) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

     dbSmtpTable mSmtpTable = mUser.getSmtpTable();
     if (mSmtpTable.getSize()<1) {
       JOptionPane.showMessageDialog(null,labels.getString("noSMTPError"),
                                          labels.getString("Error"), 1);
       return;
     }
     XAddrBookRecDlg obj=new XAddrBookRecDlg (this,labels.getString("popImapDlgTitle"),
                                              true,mSmtpTable);
     dbMailRecord record=new dbMailRecord("","","",0);
     obj.setFields(record);

     this.setVisible(false);
     obj.setVisible(true);  // call dialog

     if (obj.isOk()){
         dbMailRecord data=new dbMailRecord();
         data=obj.getFields();
         if ( data!=null ) {
            // add server into email-list
            mList2.add(data.getMail());
            jAddrList1.setListData(mList2);
            jAddrList1.setSelectedIndex(0);
            mUser.appendToAddressBook(data);

            this.jbAB_Edit.setEnabled(true);
            this.jbAB_Delete.setEnabled(true);
         } else {
           //BridgeApp.Log.println("Address Book dialog returns null");
         }
     }
     this.setVisible(true);
   }

   public static void main(String[] args) {

    dbUserPanel dbUserPanel1 = new dbUserPanel(null, false);
    dbUserPanel1.setVisible(true);
  }

  void jbAB_Delete_actionPerformed(ActionEvent e) {

     int selection=jAddrList1.getSelectedIndex();  // get index
     mList2.removeElementAt( selection ); // remove the selection from the vector
     jAddrList1.setListData( mList2 ); // update the list
     mUser.getAddressBook().delete(selection);

     if (mList2.size()<1){
      this.jbAB_Edit.setEnabled(false);
      this.jbAB_Delete.setEnabled(false);
     }

  }

  void jbPOP_Edit_actionPerformed(ActionEvent e) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

     dbMailRecord record = null;
     int select=jServerList1.getSelectedIndex();
     record = mUser.getMailTable().getRecord(select);

     XPop_ImapDlg obj=new XPop_ImapDlg(this, labels.getString("editPopMailTitles"),
                                       true);

     obj.setFields(record);
     //obj.setKeyBttn(false); // public key is not required
     this.setVisible(false);
     obj.setVisible(true);  // call dialog

     if (obj.isOk()){
      record = obj.getFields();
      mUser.getMailTable().setElementAt(record, select);
      mList1.setElementAt(record.getMailDomainAddr(), select);
      jServerList1.setListData(mList1);
      jServerList1.setSelectedIndex(select);

      }
      this.setVisible(true);
  }

  void jbAB_Edit_actionPerformed(ActionEvent e) {
  // Create xAddressBook object to edit fields of a recipient mail
  //
  //
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

     dbMailRecord record = null;
     dbSmtpTable mSmtpTable = mUser.getSmtpTable();
     int select=jAddrList1.getSelectedIndex();
     record = mUser.getAddressBook().getRecord(select);
     XAddrBookRecDlg obj=new XAddrBookRecDlg
     (this,labels.getString("editRecMailTitles"),true,mSmtpTable);

     obj.setFields(record);

     this.setVisible(false);
     obj.setVisible(true);  // call dialog

     if (obj.isOk()){
      record = obj.getFields();
      mUser.getAddressBook().setElementAt(record, select);
      mList2.setElementAt(record.getMail(), select);
      jAddrList1.setListData(mList2);
      jAddrList1.setSelectedIndex(select);
      }
      this.setVisible(true);
  }

  private boolean checkErrors(){

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

      //1. Verify if login valid
      if (jtfLogin.getText().length()<1){
          JOptionPane.showMessageDialog(null, labels.getString("loginLengthErr"), labels.getString("Error"), 1);
          return false; }
      if (!bEdit_mode && !mBank.getUserContainer().isLoginValid(jtfLogin.getText())){
          JOptionPane.showMessageDialog(null, labels.getString("invalidLoginErr"), labels.getString("Error"), 1);
          return false; }
      //2. Verify password
      if (jtfPassword.getText().length()<3){
         JOptionPane.showMessageDialog(null, labels.getString("shortPassErr"), labels.getString("Error"), 1);
         return false;}
      if (jtfPassword.getText().compareTo(jtfConfirm.getText())!=0){
         JOptionPane.showMessageDialog(null, labels.getString("passNotSameErr"), labels.getString("Error"), 1);
         return false;
      }

      if (jtfPassword_decr.getText().compareTo(jtfConfirm_decr.getText())!=0){
         JOptionPane.showMessageDialog(null,labels.getString("skPassNotSameErr"), labels.getString("Error"), 1);
         return false;
      }
      //3. Verify Display Name
      if (jtfName.getText().length()<1){
        JOptionPane.showMessageDialog(null, labels.getString("userDescrLengthErr"), labels.getString("Error"), 1);
        return false;
      }
      //4. Verify the Address Book List
      if (mList2.size()<1){
        JOptionPane.showMessageDialog(null, labels.getString("emptyAddrBookErr"), labels.getString("Error"), 1);
        return false;
      }
      //5. Verify the POP3 List
      if (mList1.size()<1){
        JOptionPane.showMessageDialog(null, labels.getString("noPopServErr"), labels.getString("Error"), 1);
        return false;
      }
      //6. Verify SMTP LIST
      if (mList3.size()<1){
        JOptionPane.showMessageDialog(null, labels.getString("noSmtpServErr"), labels.getString("Error"), 1);
        return false;
      }

      return true;
 }

  //----SMTP Buttons ----------------------------------------------------
  void jbSMTP_Delete_actionPerformed(ActionEvent e) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    int select = this.jSMTPList1.getSelectedIndex();
    // check either other user use this server or not
    Vector linked_users=null;
    linked_users=DBridgeClient.Bank().getUserContainer().getLinkedSmtpServers(mUser.getLogin(), select);
    if ( linked_users.size()>0 ){
      JOptionPane.showMessageDialog(this, labels.getString("serverUsedMsg")+" "+(String)linked_users.get(0), labels.getString("Error"), 1);
    } else {
      this.mUser.getSmtpTable().delete(select);
      this.mList3.remove(select);
      this.jSMTPList1.setListData(mList3);

      if (mList3.size()<1){
        this.jbSMTP_Edit.setEnabled(false);
        this.jbSMTP_Delete.setEnabled(false);
      }
    }

  }

  //---------------------------------------------------------------------
  void jbSMTP_Edit_actionPerformed(ActionEvent e) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

      int select = this.jSMTPList1.getSelectedIndex();
          dbSmtpRecord rec = this.mUser.getSmtpTable().getRecord(select);

          dsSmtpRecordDlg dlg = new dsSmtpRecordDlg(this, true);
          dlg.setFields(rec);
          dlg.setVisible(true);
          if (dlg.isOk()){
            rec = dlg.getFields();
            // check either other user use this server or not
             Vector linked_users=null;
             linked_users=DBridgeClient.Bank().getUserContainer().getLinkedSmtpServers(mUser.getLogin(), select);
             if ( linked_users.size()>0 ){
             // OOO to do: select dialog
              JOptionPane.showMessageDialog(this, labels.getString("serverUsedMsg")+" "+(String)linked_users.get(0)
                +labels.getString("applyInfo"), labels.getString("Error"), 1);
             } //else {
                this.mUser.getSmtpTable().setElementAt(rec, select);
                this.mList3.setElementAt(rec.getIP(), select);
                this.jSMTPList1.setListData(mList3);
                this.jSMTPList1.setSelectedIndex(select);
             //}
          }

   }
  //-------------------------------------------------------------
  void jbSMTP_New_actionPerformed(ActionEvent e) {
    dbSmtpRecord rec = new dbSmtpRecord("","","","");
    dsSmtpRecordDlg dlg = new dsSmtpRecordDlg(this, true);
    dlg.setVisible(true);

    if (dlg.isOk()){
      rec = dlg.getFields();

      this.mUser.getSmtpTable().append(rec);
      this.mList3.add(rec.getIP());

      this.jSMTPList1.setListData(mList3);
      this.jSMTPList1.setSelectedIndex(0);

      this.jbSMTP_Edit.setEnabled(true);
      this.jbSMTP_Delete.setEnabled(true);

    }

  }
//------------------------------------------------------------------------
  void jtfLogin_keyReleased(KeyEvent e) {
    if (!bName_entered)
      jtfName.setText(jtfLogin.getText());
  }
//-----------------------------------------------------------------------
  void jtfName_keyReleased(KeyEvent e) {
    if (jtfName.getText().length()>1) bName_entered = true;
    else bName_entered = false;
  }
  //-------------------------------------------------------------------


}
