package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 * Run an external software in threads
 */

 /*
 * Created: 23.09.03
 * Modified 25.05.04
 */

import java.lang.Runtime;
import java.io.*;
public class dcmStore extends Thread{

  private String mProgram[];      // software name
  private String mEnv;            // parameter list
  private File mDir;              // working dir
  private boolean mStop;          // stop flag
  private int mId;                // shows number of current process
  private Process mProc;          // process
  public dcmStore() {
    Init();
  };

  public void Init(){
    mProgram=new String[1];
    mProgram[0]=new String("dicom_store");
    mEnv=new String("");
    mDir=new File("./");
    mStop=false;
    mId=0;
  };

  public void setProgram(String str[]){
    mProgram=str;
  };
  public void setEnv(String str){
    mEnv=str;
  };
  public void setDir(String dir){
    mDir=new File(dir);
  };
  // stop the process
  public void kill(){
    mStop=true;
    System.out.println("process destroy");
    mProc.destroy();
  };
  // id of running application
  public long getId(){
    return mId;
  };

  public void run(){
     while (!mStop){
        mId=mId+1;
        running();
     }
  };

  public int running(){
     Runtime rt=Runtime.getRuntime();
     //Process proc;
     try {
       //System.out.println("Test command" +mProgram);
       int n=mProgram.length;
       for (int i=0;i<n;i++)
          System.out.print(mProgram[i]+" ");
       System.out.println("");
       mProc=rt.exec(mProgram);//,mEnv,mDir):

        // Wait for the spawned process to terminate
        mProc.waitFor();
     } catch (Exception e) {
        System.out.println(e);
     }
     return 1;
  };

  public static void main(String[] args) {
    dcmStore dcmStore1 = new dcmStore();
    String cmd[]={"./bin/storescp", "-aet", "MYAET", "-od", "tmp/", "-xcr", "\"./bin/dbcopy #p #f #c\"", "8100"};
    dcmStore1.setProgram(cmd);
    dcmStore1.start();

    //dcmStore dcmStore1 = new dcmStore();
   // String cmd[]={"storescp", "-aet", "MYAET", "-od", "tmp/", "-xcr", "\"dbcopy #p #f #c\"", "8100"};
    //dcmStore1.setProgram(cmd);
    //dcmStore1.setProgram("notepad");
    //dcmStore1.start();
    //System.out.println("notepad");
    //System.out.println(dcmStore1.getId());
  };
}// end class
