package dbridge;

import java.io.Serializable;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

/*
* Modified 15.12.04 BOB add Cloneable and copy-consructor
*/

public class dsDcmServerClass implements Serializable, Cloneable {
  protected String mDcmServer;
  protected String mDcmPort;
  protected String mDcmAeTitle;
  protected String mComments;

  //Default constructor
  public dsDcmServerClass() {
         mDcmServer = "";
         mDcmPort = "";
         mDcmAeTitle = "";
         mComments = "";
  }

  //Constructor
  public dsDcmServerClass(String DcmServer, String DcmPort, String DcmAeTitle,
                          String Comments) {
         mDcmServer = DcmServer;
         mDcmPort = DcmPort;
         mDcmAeTitle = DcmAeTitle;
         mComments = Comments;
  }

  public dsDcmServerClass(dsDcmServerClass obj) {
    this.copy(obj);
  }

  public void copy (dsDcmServerClass obj) {
         mDcmServer = obj.getDcmServer();
         mDcmPort = obj.getDcmPort();
         mDcmAeTitle = obj.getDcmAeTitle();
         mComments = obj.getComments();
  }

  public Object clone(){
    return new dsDcmServerClass(this);
  }

   //====SET/GET stuff =====
   public void setDcmServer (String DcmServer) {mDcmServer = DcmServer;}
   public void setDcmPort (String DcmPort) {mDcmPort = DcmPort;}
   public void setDcmAeTitle (String DcmAeTitle) {mDcmAeTitle = DcmAeTitle;}
   public void setComments (String Comments) {mComments = Comments;}

   public String getDcmServer () {return mDcmServer;}
   public String getDcmPort () {return mDcmPort;}
   public String getDcmAeTitle () {return mDcmAeTitle;}
   public String getComments () {return mComments;}
   // format, used in DCM Server select dialog
   public String toString() {return new String (mDcmServer +" : "+mDcmPort + " : "+mDcmAeTitle);}

    public void print(){
    System.out.println(mDcmServer);
    System.out.println(mDcmPort);
    System.out.println(mDcmAeTitle);
    System.out.println(mComments);
  }

    public static void main(String[] args) {
    System.out.println("Test DcmServer");
    dsDcmServerClass obj = new dsDcmServerClass("Server", "port", "AEMT", "Comments");
    obj.print();
  }

}
