package dbridge;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.awt.event.*;


/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

public class dsIniFileEditFrame extends JFrame {

  boolean dirty = false;
  String File_name = new String();

  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JButton bOk = new JButton();
  JButton bCancel = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout2 = new BorderLayout();
  JTextArea jTextArea1 = new JTextArea();
  Document document1;

  public boolean isChanged(){
    return dirty;
  }

  public boolean saveFile() {

   try
    {
      // Open a file of the current name.
      File file = new File (File_name);

      // Create an output writer that will write to that file.
      // FileWriter handles international characters encoding conversions.
      FileWriter out = new FileWriter(file);
      String text = jTextArea1.getText();
      out.write(text);
      out.close();
      this.dirty = false;
      return true;
    }
    catch (IOException e) {
      JOptionPane.showMessageDialog(this, "Error opening " + File_name);
    }
    return false;
  }

  public void setPanelMode(){
    this.jPanel2.setVisible(false);
  }

    // Check if file is dirty.
  // If so get user to make a "Save? yes/no/cancel" decision.
  boolean okToAbandon() {
    if (!dirty) {
      return true;
    }
    int value =  JOptionPane.showConfirmDialog(this, "Save changes?",
                                         "Text Edit", JOptionPane.YES_NO_CANCEL_OPTION) ;

    switch (value) {
       case JOptionPane.YES_OPTION:
         // yes, please save changes
         return saveFile();
       case JOptionPane.NO_OPTION:
         // no, abandon edits
         // i.e. return true without saving
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // cancel
         return false;
    }
  }


    // Open named file; read text from file into jTextArea1; report to statusBar.
  void openFile(String fileName)  {
    try
    {
      // Open a file of the given name.
      File file = new File(fileName);
      int size = (int)file.length();
      int chars_read = 0;

      FileReader in = new FileReader(file);
      char[] data = new char[size];

      while(in.ready()) {
         chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();
      jTextArea1.setText(new String(data, 0, chars_read));
      this.dirty = false;

    }
    catch (IOException e)
    {
      JOptionPane.showMessageDialog(this, "Error opening " + fileName);
    }
  }


  public dsIniFileEditFrame(String Filename) {
    try {
      this.File_name = Filename;
      jbInit();
      this.openFile(File_name);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    document1 = jTextArea1.getDocument();
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(500, 400));
    this.setTitle("Ini File Editor");
    jPanel1.setBorder(BorderFactory.createLineBorder(Color.black));
    jPanel1.setLayout(borderLayout2);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    bOk.setText("Ok");
    bOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bOk_actionPerformed(e);
      }
    });
    bCancel.setText("Cancel");
    bCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bCancel_actionPerformed(e);
      }
    });
    borderLayout1.setHgap(2);
    borderLayout1.setVgap(2);
    jTextArea1.setText("");
    document1.addDocumentListener(new javax.swing.event.DocumentListener() {
      public void insertUpdate(DocumentEvent e) {
        document1_changedUpdate(e);
      }
      public void removeUpdate(DocumentEvent e) {
        document1_changedUpdate(e);
      }
      public void changedUpdate(DocumentEvent e) {
        document1_changedUpdate(e);
      }
    });
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(bOk, null);
    jPanel2.add(bCancel, null);
    jPanel1.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextArea1, null);

  }


   public static void main(String[] args) {
          dsIniFileEditFrame frame = new dsIniFileEditFrame("F:\\test\\test_1111_Loc\\111.txt");
          frame.setVisible(true);
       }

  void document1_changedUpdate(DocumentEvent e) {
      dirty = true;
  }

  void bOk_actionPerformed(ActionEvent e) {
      this.okToAbandon();
      this.setVisible(false);
  }

  void bCancel_actionPerformed(ActionEvent e) {
      this.setVisible(false);
  }


}
