package dbridge;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class dsSignKeyDialog extends JDialog {

  private boolean mOk = false;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JLabel jlPass = new JLabel();
  JPasswordField jPasswordField1 = new JPasswordField();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton jbOk = new JButton();
  JButton jbCancel = new JButton();
  Box box1;
  JRadioButton jrb0 = new JRadioButton();
  JRadioButton jrb1 = new JRadioButton();
  JRadioButton jrb2 = new JRadioButton();
  JRadioButton jrb3 = new JRadioButton();
  JLabel jLabel1 = new JLabel();
  ButtonGroup buttonGroup1 = new ButtonGroup();


  public dsSignKeyDialog(JDialog parent, boolean modal) throws HeadlessException {
     super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setSize(new Dimension(394, 248));
    this.setTitle("Sign Key");

    box1 = Box.createVerticalBox();
    this.getContentPane().setLayout(borderLayout1);
    jlPass.setText("Passphrase for secret key:");
    jPasswordField1.setText("jPasswordField1");
    jPanel3.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setMinimumSize(new Dimension(213, 100));
    jPanel1.setPreferredSize(new Dimension(213, 100));
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jbOk.setText("Ok");
    jbOk.addActionListener(new dsSignKeyDialog_jbOk_actionAdapter(this));
    jbCancel.setText("Cancel");
    jbCancel.addActionListener(new dsSignKeyDialog_jbCancel_actionAdapter(this));
    jrb0.setSelected(false);
    jrb0.setText("I will not answer.");
    jrb1.setText("I have not checked at all.");
    jrb2.setSelected(true);
    jrb2.setText("I have done casual checking.");
    jrb3.setText("I have done very careful checking.");
    jLabel1.setMaximumSize(new Dimension(250, 45));
    jLabel1.setMinimumSize(new Dimension(250, 15));
    jLabel1.setPreferredSize(new Dimension(250, 25));
    jLabel1.setText("How carefully have you verified the key?");
    jPasswordField1.setMinimumSize(new Dimension(200, 23));
    jPasswordField1.setPreferredSize(new Dimension(200, 23));
    jPasswordField1.setText("");
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    this.getContentPane().add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jlPass, null);
    jPanel3.add(jPasswordField1, null);
    jPanel2.add(jbOk, null);
    jPanel2.add(jbCancel, null);
    jPanel1.add(box1, null);

    box1.add(jLabel1, null);
    box1.add(jrb0, null);
    box1.add(jrb1, null);
    box1.add(jrb2, null);
    box1.add(jrb3, null);

    buttonGroup1.add(jrb0);
    buttonGroup1.add(jrb1);
    buttonGroup1.add(jrb2);
    buttonGroup1.add(jrb3);
  }

  void jbOk_actionPerformed(ActionEvent e) {
    mOk = true;
    this.setVisible(false);
  }

  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    this.setVisible(false);
  }

  public int getLevel(){
    int level = 0;
    if (this.jrb1.isSelected()) level=1;
    else if (this.jrb2.isSelected()) level=2;
    else if (this.jrb3.isSelected()) level=3;
    return level;
  }

  public boolean isOk(){return mOk;}

  public String getPass(){
    return new String(this.jPasswordField1.getPassword());
  }

}

class dsSignKeyDialog_jbOk_actionAdapter implements java.awt.event.ActionListener {
  dsSignKeyDialog adaptee;

  dsSignKeyDialog_jbOk_actionAdapter(dsSignKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbOk_actionPerformed(e);
  }
}

class dsSignKeyDialog_jbCancel_actionAdapter implements java.awt.event.ActionListener {
  dsSignKeyDialog adaptee;

  dsSignKeyDialog_jbCancel_actionAdapter(dsSignKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbCancel_actionPerformed(e);
  }
}
