package dbridge;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.border.*;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author aITLab
 * @version 1.0
 */

public class dsSmtpRecordDlg extends JDialog {

  dbSmtpRecord mSmtpRecord = new dbSmtpRecord("","","","");;
  boolean mOk = false;
  private ResourceBundle lbls = null;

  JPanel jPanel1 = new JPanel();
  Box box1;
  FlowLayout flowLayout1 = new FlowLayout();
  ServerField jtfIP = new ServerField();
  JLabel jLabel1 = new JLabel();
  JPanel jPanel2 = new JPanel();
  FlowLayout flowLayout2 = new FlowLayout();
  JPasswordField jtfPass = new JPasswordField();
  JLabel jLabel2 = new JLabel();
  JPanel jPanel3 = new JPanel();
  FlowLayout flowLayout3 = new FlowLayout();
  EmailField jtfLogin = new EmailField();
  JLabel jLabel3 = new JLabel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  JTextArea jTextArea1 = new JTextArea();
  JPanel jPanel6 = new JPanel();
  FlowLayout flowLayout4 = new FlowLayout();
  JButton jbOk = new JButton();
  JButton jbCancel = new JButton();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel7 = new JPanel();
  FlowLayout flowLayout5 = new FlowLayout();
  JPasswordField jtfConfirm = new JPasswordField();
  JLabel jLabel5 = new JLabel();
  JPanel jPanel8 = new JPanel();
  FlowLayout flowLayout6 = new FlowLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  TitledBorder titledBorder3;
  TitledBorder titledBorder4;
  JScrollPane jScrollPane1 = new JScrollPane();
  FlowLayout flowLayout7 = new FlowLayout();
  JTextField jtfPort = new JTextField();
  JLabel jLabel7 = new JLabel();
  JPanel jPanel9 = new JPanel();
  JCheckBox jcbSSL = new JCheckBox();
  
  // 24.09.07
  JPanel    email_pnl  = new JPanel();
  FlowLayout email_flt = new FlowLayout();
  JLabel    email_lbl  = new JLabel();
  EmailField email_tf  = new EmailField();
  
//------------------------------------------------------------------------
  public dsSmtpRecordDlg(Dialog parent, boolean modal) {
  super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
//---------------------------------------------------------------------------
  public dsSmtpRecordDlg(Frame parent, boolean modal) {
  super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
//---------------------------------------------------------------------------


  private void jbInit() throws Exception {
    Locale currentLocale = BridgeApp.getCurrentLocale();
    lbls = ResourceBundle.getBundle("dbridge.prop.dsSmtpRecordDlgBundle",
                                     currentLocale);

    box1 = Box.createVerticalBox();

    titledBorder1 = new TitledBorder(lbls.getString("title1"));
    titledBorder2 = new TitledBorder(lbls.getString("title2"));
    titledBorder3 = new TitledBorder(lbls.getString("title3"));
    titledBorder4 = new TitledBorder(lbls.getString("title4"));

    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(450, 370));
    this.setMinimumSize(new Dimension(450, 370));
    this.setPreferredSize(new Dimension(450, 370));
    this.setTitle(lbls.getString("title"));

    // SMTP Parameters
    jPanel1.setBorder(titledBorder1);
    jPanel1.setLayout(borderLayout2);
    jtfIP.setMinimumSize(new Dimension(200, 25));
    jtfIP.setPreferredSize(new Dimension(200, 25));
    jtfIP.setBounds(new Rectangle(103, 27, 63, 21));
    // password
    jLabel1.setMaximumSize(new Dimension(120, 17));
    jLabel1.setMinimumSize(new Dimension(120, 17));
    jLabel1.setPreferredSize(new Dimension(120, 17));
    jLabel1.setText(lbls.getString("Server_name"));
    jLabel1.setBounds(new Rectangle(22, 23, 41, 17));
    jPanel2.setLayout(flowLayout1);
    jtfPass.setBounds(new Rectangle(103, 27, 63, 21));
    jtfPass.setPreferredSize(new Dimension(200, 25));
    jtfPass.setMinimumSize(new Dimension(200, 25));
    jLabel2.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel2.setMaximumSize(new Dimension(120, 17));
    jLabel2.setMinimumSize(new Dimension(120, 17));
    jLabel2.setPreferredSize(new Dimension(120, 17));
    jLabel2.setText(lbls.getString("password"));
    jPanel3.setLayout(flowLayout2);
    jtfLogin.setBounds(new Rectangle(103, 27, 63, 21));
    // user name
    jtfLogin.setPreferredSize(new Dimension(200, 25));
    jtfLogin.setMinimumSize(new Dimension(200, 25));
    jLabel3.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel3.setMaximumSize(new Dimension(120, 17));
    jLabel3.setMinimumSize(new Dimension(120, 17));
    jLabel3.setPreferredSize(new Dimension(120, 17));
    jLabel3.setText(lbls.getString("username"));
    jPanel4.setLayout(flowLayout3);
    flowLayout1.setVgap(0);
    flowLayout3.setVgap(0);
    flowLayout2.setVgap(0);
    jPanel5.setBorder(titledBorder2);
    jPanel5.setLayout(borderLayout3);
    jTextArea1.setBorder(BorderFactory.createLoweredBevelBorder());
    jTextArea1.setText(lbls.getString("txt_area1"));
    jPanel6.setBorder(titledBorder4);
    jPanel6.setLayout(flowLayout4);
    jbOk.setText(lbls.getString("bOk"));
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });
    jbCancel.setText(lbls.getString("bCancel"));
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });
    jPanel7.setLayout(flowLayout5);
    flowLayout5.setVgap(0);
    jtfConfirm.setBounds(new Rectangle(103, 27, 63, 21));
    jtfConfirm.setPreferredSize(new Dimension(200, 25));
    jtfConfirm.setMinimumSize(new Dimension(200, 25));
    jLabel5.setBounds(new Rectangle(22, 23, 41, 17));
    jLabel5.setMaximumSize(new Dimension(120, 17));
    jLabel5.setMinimumSize(new Dimension(120, 17));
    jLabel5.setPreferredSize(new Dimension(120, 17));
    jLabel5.setText(lbls.getString("confirm"));
    jPanel8.setLayout(flowLayout6);
    flowLayout6.setVgap(0);
    borderLayout3.setHgap(5);
    borderLayout3.setVgap(5);
    borderLayout1.setHgap(10);
    flowLayout7.setVgap(0);
    jtfPort.setMinimumSize(new Dimension(200, 25));
    jtfPort.setText(lbls.getString("porttype"));
    jtfPort.setPreferredSize(new Dimension(200, 25));
    jtfPort.setBounds(new Rectangle(103, 27, 63, 21));
    jLabel7.setText(lbls.getString("port"));
    jLabel7.setPreferredSize(new Dimension(120, 17));
    jLabel7.setMinimumSize(new Dimension(120, 17));
    jLabel7.setMaximumSize(new Dimension(120, 17));
    jLabel7.setBounds(new Rectangle(22, 23, 41, 17));
    jPanel9.setLayout(flowLayout7);
    jcbSSL.setMaximumSize(new Dimension(325, 25));
    jcbSSL.setMinimumSize(new Dimension(325, 25));
    jcbSSL.setPreferredSize(new Dimension(325, 25));
    jcbSSL.setSelected(true);
    jcbSSL.setText(lbls.getString("ssl_msg"));
    jcbSSL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jcbSSL_actionPerformed(e);
      }
    });
    // email 24.09.07
    //email_pnl.setBorder(titledBorder1);
    email_pnl.setLayout(email_flt);
    email_lbl.setText(lbls.getString("email"));
    email_lbl.setPreferredSize(new Dimension(120, 17));
    email_lbl.setMinimumSize(new Dimension(120, 17));
    email_lbl.setMaximumSize(new Dimension(120, 17));
    email_lbl.setBounds(new Rectangle(22, 23, 41, 17));
    email_tf.setMinimumSize(new Dimension(200, 25));
    email_tf.setPreferredSize(new Dimension(200, 25));
    email_tf.setBounds(new Rectangle(103, 27, 63, 21));
    
    
    jPanel1.add(box1, BorderLayout.CENTER);
    box1.add(jPanel2, null);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jtfIP, null);
    jPanel9.add(jLabel7, null);
    jPanel9.add(jtfPort, null);
    jPanel7.add(jLabel5, null);
    jPanel7.add(jtfConfirm, null);
    box1.add(jPanel4, null);
    jPanel4.add(jLabel3, null);
    jPanel4.add(jtfLogin, null);
    box1.add(jPanel3, null);
    jPanel3.add(jLabel2, null);
    jPanel3.add(jtfPass, null);
    box1.add(jPanel7, null);
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jtfIP, null);
    jPanel3.add(jLabel2, null);
    jPanel3.add(jtfPass, null);
    jPanel4.add(jLabel3, null);
    jPanel4.add(jtfLogin, null);
    this.getContentPane().add(jPanel5, null);
    jPanel5.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextArea1, null);
    this.getContentPane().add(jPanel6,  BorderLayout.SOUTH);
    jPanel6.add(jbOk, null);
    jPanel6.add(jbCancel, null);
    jPanel7.add(jLabel5, null);
    jPanel7.add(jtfConfirm, null);
    box1.add(jPanel9, null);
    box1.add(jPanel8, null);
    jPanel8.add(jcbSSL, null);
    jPanel9.add(jLabel7, null);
    jPanel9.add(jtfPort, null);
    
    // email
    box1.add(email_pnl);
    email_pnl.add(email_lbl, null);
    email_pnl.add(email_tf, null);
  }
  //-------------------------------------------------------------------------
  public void setFields(dbSmtpRecord obj){
      if (obj != null){
      this.mSmtpRecord = obj;
      this.jtfIP.setText(this.mSmtpRecord.getIP());
      this.jtfLogin.setText(this.mSmtpRecord.getLogin());
      this.jtfPass.setText(this.mSmtpRecord.getPassword());
      this.jtfConfirm.setText(this.mSmtpRecord.getPassword());
      this.jTextArea1.setText(this.mSmtpRecord.getComments());
      if (this.mSmtpRecord.isSSL())
        this.jcbSSL.setSelected(true);
      else this.jcbSSL.setSelected(false);
      this.jtfPort.setText(Integer.toString(this.mSmtpRecord.getPort()));
      // if the From record is "", fill the field automatically using the user name and the host name 
      if ( this.mSmtpRecord.getFrom().compareTo("")==0 &&
    		  this.mSmtpRecord.getIP().compareTo("")!=0 && this.mSmtpRecord.getLogin().compareTo("")!=0 )
    	 this.email_tf.setText(this.mSmtpRecord.getLogin()+"@"+this.mSmtpRecord.getIP());
      else
         this.email_tf.setText(this.mSmtpRecord.getFrom());
      this.email_tf.setToolTipText("EMail From");
      }
  }
 //--------------------------------------------------------------------------
  public dbSmtpRecord getFields(){

      return this.mSmtpRecord;

  }
 //--------------------------------------------------------------------------
  private void fillFields(){

    this.mSmtpRecord.setIP(this.jtfIP.getText());
    this.mSmtpRecord.setLogin(this.jtfLogin.getText());
    this.mSmtpRecord.setCommants(this.jTextArea1.getText());
    this.mSmtpRecord.setPassword(new String (this.jtfPass.getPassword()));
    this.mSmtpRecord.setPort(Integer.valueOf(jtfPort.getText()).intValue());
    if (this.jcbSSL.isSelected()) this.mSmtpRecord.setSSL(true);
    else this.mSmtpRecord.setSSL(false);
    // if the From record is "", fill the field automatically using the user name and the host name 
    if ( this.email_tf.getText().compareTo("")==0 &&
    	 this.jtfIP.getText().compareTo("")!=0 && this.jtfLogin.getText().compareTo("")!=0 )
    	this.mSmtpRecord.setFrom(this.jtfLogin.getText()+"@"+this.jtfIP.getText());
    else
        this.mSmtpRecord.setFrom(this.email_tf.getText());
  }
 //--------------------------------------------------------------------------
 void jcbSSL_actionPerformed(ActionEvent e) {
    if (this.jcbSSL.isSelected())
      this.jtfPort.setText(lbls.getString("sslport"));
    else this.jtfPort.setText(lbls.getString("smtpport"));
  }
 //-----------------------------------------------------------------------
  public boolean isOk(){
    return mOk;
  }
 //--------------------------------------------------------------------------

  void jbOk_actionPerformed(ActionEvent e) {
    if (!chkErrors()) return;

    this.fillFields();
    this.mOk = true;
    this.setVisible(false);
  }
//---------------------------------------------------------------------------
  void jbCancel_actionPerformed(ActionEvent e) {
    this.mOk = false;
    this.setVisible(false);
  }
  //------------------------------------------------------------------------
  boolean chkErrors (){
    if (jtfIP.getText().length()<1){
      JOptionPane.showMessageDialog(this, lbls.getString("serv_msg"),
                                   "SMTP", JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (jtfLogin.getText().length()<1){
      JOptionPane.showMessageDialog(this, lbls.getString("user_msg"),
                                    "SMTP", JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (jtfPort.getText().length()<1){
      JOptionPane.showMessageDialog(this, lbls.getString("port_msg"),
                                    "SMTP", JOptionPane.QUESTION_MESSAGE);
      return false;
    }
    
    if (email_tf.getText().length()<1){
        JOptionPane.showMessageDialog(this, lbls.getString("email_msg"),
                                      "SMTP", JOptionPane.QUESTION_MESSAGE);
        return false;
      }

    //TODO perhaps need to change new String ...
    if ((new String (jtfPass.getPassword())).
        compareTo(new String (jtfConfirm.getPassword()))!=0){
         JOptionPane.showMessageDialog(this,
         lbls.getString("passwd_msg"),
          "SMTP", JOptionPane.WARNING_MESSAGE);
         return false; }

    return true;
  }
//------------------------------------------------------------------------------

//================= DEBUG -----------------------
//   public static void main(String[] args) {
//    dsSmtpRecordDlg dsSmtpRecordDlg1 = new dsSmtpRecordDlg(null, true);
//    dsSmtpRecordDlg1.setVisible(true);
//  }


 //-------------------------------------------------------------------------

}
