package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Modified 10.02.06
 * Modified 11.06.06
 * Modified 29.06.06
 * Modified  2.07.06
 */


import java.sql.*;
import java.util.StringTokenizer;

public class vfilesRecord
{
    /**
     * Default constructor
     */
    public vfilesRecord(){
        Init();
    }
    /**
     * Parammetrized constructor
     * @param str String
     */
    public vfilesRecord(String str){
        Init(str);
    }

    /**
     * print fields
     * @params a result set
     * @throws SQLExeption
     */
    public void print() throws SQLException {
            System.out.println("i: "+m_dn_index +
            "\n id: "    +m_id +
            "\n name: "  +m_name +
            "\n sent: "  +m_number+
            "\n report: "+m_report+
            "\n mid: "   +m_mid+
            "\n status: "+m_status);
        System.out.println();
    }

    /**
     * convert the record to a string
     * @return String
     */
    public String toString(){
      String res= (new Integer(m_dn_index)).toString();
            res+="\n" + m_id;
            res+="\n" + m_name;
            res+="\n" + (new Integer(m_number)).toString();
            res+="\n" + m_report;
            res+="\n" + m_mid;
            res+="\n" + m_status;
      return res;
    }
    /**
     * convert a record from a string
     * @param str String
     */
    public void fromString(String str){
      StringTokenizer token=new StringTokenizer(str,"\n");
      String var = new String(token.nextToken() );
      int item=0;
      while ( var!=null ){
        switch (item) {
          case 0:
            m_dn_index = Integer.parseInt(var);
            break;
          case 1:
            m_id = var;
            break;
          case 2:
            m_name = var;
            break;
          case 3:
            m_number = Integer.parseInt(var);
            break;
          case 4:
            m_report = var;
            break;
          case 5:
            m_mid = var;
            break;
          case 6:
            if ( var.equals("1") ) m_status = true;
            else m_status = false;
            break;
        }
        if (token.hasMoreTokens()) {
            var = new String(token.nextToken());
        } else {
            var = null;
        }
        item++;
      }// end while
    }// end fromString

    /**
     * convert the record to a report string
     * @return String
     */
    public String toReportString(){
      String res= ("-- File record number : " + new Integer(m_dn_index)).toString();
            res+="\n-- Transaction ID : " + m_id;
            res+="\n-- File name : " + m_name;
            res+="\n-- File number : " + (new Integer(m_number)).toString();
            res+="\n-- Report : " + m_report;
            res+="\n-- Message ID : " + m_mid;
            if ( m_status )
                res+="\n-- Status : file transaction is opened\n";
            else
                res+="\n-- Status : file transaction is closed\n";
      return res;
    }


    public String m_name=new String();  // file name
    public String m_id=new String();    // Global Message ID
    public int m_dn_index;              // table index (key)
    public int m_number;                // file number in a selection
    public String m_report;             // message about the file
    public String m_mid;                // message id
    public boolean m_status;            // open transaction status

    /**
     * Init method
     */
    private void Init(){
        m_id       = "null";
        m_name     = "null";
        m_dn_index = 0;
        m_number   = 0;
        m_report   = "null";
        m_mid      = "null";
        m_status   = true;
    }
    private void Init(String str){
      this.fromString(str);
    }

    public static void main(String[] args){
        vfilesRecord rec1=new vfilesRecord();
        System.out.println("Get the record as a string");
        String copy=rec1.toString();
        System.out.println("This string represents the record:\n"+copy);

        System.out.println("Create a new record using the string");
        vfilesRecord rec2= new vfilesRecord(copy);
        System.out.println(rec2.toString());
    }

}
