package dbridge;

import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;

public class CSignedEncryptedMessageBuilder extends CEncryptedMessageBuilder {

    public CSignedEncryptedMessageBuilder(String sComments, String sxTag,
                                                          String sPublicKey) {
      super(sComments, sxTag, sPublicKey);
    }

/**
  "PlainPart" here means "unencrypted part" 
*/
    protected void ApplyGPG(MimeBodyPart mbpPlainPart, String sFileName) 
    throws MessagingException,IOException,wrapperException {
      ByteArrayOutputStream outStream = new ByteArrayOutputStream();
      mbpPlainPart.writeTo(outStream);
      String[] sPublicKeys = {mPublicKey};
      GpgWrapper.signEncrypt(outStream, sPublicKeys, sFileName, mSecretKey, mPass);
    }
}
