package dbridge;

import javax.swing.text.BadLocationException;
import java.awt.Toolkit;
import javax.swing.text.AttributeSet;
import javax.swing.text.PlainDocument;

/**
 * <p>Title: dbridge</p>
 *
 * <p>Description: </p>
 * This Document makes some text fields or table cells to be change-validated.
 * Only folowing characters are allowed for the login field
 * A|..|Z|a|...|z|0|...|9|_
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 * @author OOO
 * @version 1.0
 */
public class LoginFieldDocument
    extends PlainDocument {
  public void insertString(int offs,
                           String str,
                           AttributeSet a) throws BadLocationException {

    char[] source = str.toCharArray();
    char[] result = new char[source.length];
    int j = 0;
    for (int i = 0; i < result.length; i++) {
        if ( (source[i]>='A' && source[i]<='z') ||
             Character.isDigit(source[i]) ||
             source[i]=='_' ){
          result[j++] = source[i];
        } else {
          Toolkit.getDefaultToolkit().beep();
        }
    }
    super.insertString(offs, new String(result, 0, j), a);
  }
}// end class
