package dbridge;
import java.io.*;
import java.util.*;
import java.net.URL;

public class PageReader
{
	public static BufferedReader read(String url) throws Exception{
		return new BufferedReader(
			new InputStreamReader(
				new URL(url).openStream()
            )
        );
    }
    /**
     * Read mage from a buffer and select a version
     */
    public String getTextFollowing(String url, String str) throws Exception{
		BufferedReader reader = read(url);
		String line = reader.readLine();
        boolean next_token = false;
		while (line != null ) {
            StringTokenizer token = new StringTokenizer(line, " ");
            String currentToken="";
            while( token.hasMoreTokens() ){
                currentToken = token.nextToken();
                if ( next_token ){
                    return currentToken;
                } else{
                    if( currentToken.equals(str) ){
                       next_token = true;
                    }
                }
            }
            line = reader.readLine();
        }
        return "";
    }

// DEBUG
	public static void main (String[] args) throws Exception{
		PageReader obj= new PageReader();
        String res=obj.getTextFollowing(args[0],"Version");
        System.out.println(res);
    }
}
