package dbridge;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/**
 * The call used to display and select SMTP servers during creation an address
 * book record
 *
 */

public class XSelSmtpSrvDlg extends JDialog {

    boolean mOk=false;
    Vector servers;



  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList jlservers = new JList();
  BorderLayout borderLayout3 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  JButton jbOk = new JButton();
  JPanel jPanel2 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton jbCancel = new JButton();
  BorderLayout borderLayout1 = new BorderLayout();




  //-----------------------------------------------------------------------
  public XSelSmtpSrvDlg(JFrame parent, boolean modal, Vector vSmtpSrvList) {
  super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }

    if (vSmtpSrvList != null){
      servers = vSmtpSrvList;
      jlservers.setListData(servers);
      jlservers.setSelectedIndex(0);
    }

  }

  //=====================================================================
  public static void main(String[] args) {

    Vector vSmtpSrvList = new Vector();
    dbSmtpRecord s1  = new dbSmtpRecord("first", "", "", "");
    dbSmtpRecord s2  = new dbSmtpRecord("second", "", "", "");
    dbSmtpRecord s3  = new dbSmtpRecord("third", "", "", "");
    vSmtpSrvList.add(s1);
    vSmtpSrvList.add(s2);
    vSmtpSrvList.add(s3);

    XSelSmtpSrvDlg dsSelSmtpSrvDlg1 = new XSelSmtpSrvDlg(null, false, vSmtpSrvList);
    dsSelSmtpSrvDlg1.setVisible(true);

  }

  //==========================================================================
  private void jbInit() throws Exception {
    jPanel1.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel1.setLayout(borderLayout3);
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(386, 250));
    this.setTitle("Select Server");
    jLabel2.setText("Select Smtp Server:");
    jbOk.setText("Ok");
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });
    jPanel2.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel2.setLayout(flowLayout1);
    jbCancel.setText("Cancel");
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });
    jPanel1.add(jScrollPane2, BorderLayout.CENTER);
    jPanel1.add(jLabel2, BorderLayout.NORTH);
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(jbOk, null);
    jPanel2.add(jbCancel, null);
    jScrollPane2.getViewport().add(jlservers, null);
    this.getContentPane().add(jPanel1,  BorderLayout.CENTER);
  }
 //------------------------------------------------------------------------

  public boolean isOk(){
    return mOk;
  }

 //------------------------------------------------------------------------
  void jbOk_actionPerformed(ActionEvent e) {
    mOk = true;
    this.setVisible(false);
  }
  //-----------------------------------------------------------------------
  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    this.setVisible(false);
  }
  //-----------------------------------------------------------------------
  dbSmtpRecord getSelectedServer(){
    return (dbSmtpRecord) jlservers.getSelectedValue();
  }
  //-----------------------------------------------------------------------
  int getSelectedIndex(){
    return jlservers.getSelectedIndex();
  }

  //------------------------------------------------------------------------
}
