package dbridge;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 * Services panel. Administrator is able to control the server services.
 */

/*
* Created: 18.10.04
*/

public class XServices extends JFrame{
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JPanel jPanel5 = new JPanel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JButton jButton3 = new JButton();
  JButton jButton4 = new JButton();
  JButton jButton5 = new JButton();
  JLabel jLabel1 = new JLabel();    // binary status lable
  JLabel jLabel3 = new JLabel();
  JPasswordField jTextField1 = new JPasswordField();
  FlowLayout flowLayout1 = new FlowLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  TitledBorder titledBorder3;
  TitledBorder titledBorder4;
  TitledBorder titledBorder5;

  // labels
  private String mStatusRun;//="Running ...";
  private String mStatusStop;//="Sleeping ...";
  private String mLabelTitleBorder1;
  private String mLabelTitleBorder2;
  private String mLabelTitleBorder3;
  private String mLabelTitleBorder4;
  private String mLabelTitleBorder5;
  private String mLabelButton1;
  private String mLabelButton2;
  private String mLabelButton3;
  private String mLabelButton4;
  private String mLabelButton5;
  private String mLabelLabel3;
  private String mLabelStopMsg1;
  private String mLabelStopMsg2;
  private String mLabelTitle1;

  public XServices() {
    setLocale();  // national labels
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public XServices(String title) {
    super(title);
    setLocale();  // national labels
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setResizable(false);
    setIconImage(Toolkit.getDefaultToolkit().getImage(DBConsts.WINDOW_ICON_FILENAME));
    titledBorder1 = new TitledBorder(BorderFactory.createTitledBorder(mLabelTitleBorder1)); //"Shutdown:"
    titledBorder2 = new TitledBorder(BorderFactory.createTitledBorder(mLabelTitleBorder2)); //Operations requires Admin rights
    titledBorder3 = new TitledBorder(BorderFactory.createTitledBorder(mLabelTitleBorder3)); // Operations require Admin rights
    titledBorder4 = new TitledBorder(BorderFactory.createTitledBorder(mLabelTitleBorder4));//Service command:
    titledBorder5 = new TitledBorder(BorderFactory.createTitledBorder(mLabelTitleBorder5));// Status:
    jButton1.setAlignmentY((float) 0.5);
    jButton1.setPreferredSize(new Dimension(110, 27));
    jButton1.setText(mLabelButton1);//"Start"
    jButton1.setIcon(new ImageIcon("./lib/res/redflag.gif"));
    jButton1.addActionListener(new XServices_jButton1_actionAdapter(this));
    jButton2.setPreferredSize(new Dimension(110, 27));
    jButton2.setText(mLabelButton2); //"Restart"
    jButton2.setIcon(new ImageIcon("./lib/res/greenflag.gif"));
    jButton2.addActionListener(new XServices_jButton2_actionAdapter(this));
    jButton3.setPreferredSize(new Dimension(110, 27));
    jButton3.setText(mLabelButton3);// "Stop"
    jButton3.setIcon(new ImageIcon("./lib/res/stop.gif"));
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton3_actionPerformed(e);
      }
    });
    jButton4.setPreferredSize(new Dimension(100, 27));
    jButton4.setText(mLabelButton4);//"Now"
    jButton4.setIcon(new ImageIcon("./lib/res/clockn.gif"));
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton4_actionPerformed(e);
      }
    });
    jButton5.setPreferredSize(new Dimension(150, 27));
    jButton5.setText(mLabelButton5);//"When ready"
    jButton5.setIcon(new ImageIcon("./lib/res/clock.gif"));
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton5_actionPerformed(e);
      }
    });
    jLabel3.setText(mLabelLabel3);//"Password:"
    jLabel3.setIcon(new ImageIcon("./lib/res/key.gif"));
    jTextField1.setMinimumSize(new Dimension(30, 24));
    jTextField1.setPreferredSize(new Dimension(150, 24));
    jTextField1.addActionListener(new XServices_jTextField1_actionAdapter(this));
    //jTextField1.setE
    jPanel2.setLayout(flowLayout1);
    jPanel5.setBorder(titledBorder3);
    jPanel5.setPreferredSize(new Dimension(360, 63));
    jPanel3.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
    jPanel3.setBorder(titledBorder1);
    jPanel3.setDebugGraphicsOptions(0);
    jPanel3.setPreferredSize(new Dimension(360, 66));
    jPanel2.setBorder(titledBorder4);
    jPanel2.setPreferredSize(new Dimension(360, 100));
    jPanel1.setBorder(null);
    jPanel1.setMinimumSize(new Dimension(243, 260));
    jPanel1.setPreferredSize(new Dimension(400, 260));
    jPanel1.setRequestFocusEnabled(true);
    jLabel1.setText(mStatusRun);
    jLabel1.setIcon(new ImageIcon("./lib/res/computer.png"));
    jPanel4.setBorder(titledBorder5);
    jPanel4.setPreferredSize(new Dimension(360, 57));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel4, null);
    jPanel1.add(jPanel2, null);

    jPanel2.add(jButton1, null);
    jPanel2.add(jButton2, null);
    jPanel2.add(jButton3, null);

    jPanel1.add(jPanel3, null);
    jPanel3.add(jButton4, null);
    jPanel3.add(jButton5, null);
    jPanel1.add(jPanel5, null);
    jPanel5.add(jLabel3, null);
    jPanel5.add(jTextField1, null);
    jPanel4.add(jLabel1, null);
    this.setActive(false);

    this.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent ev){
          dispose();
        }
      });
  }

  private void setStatus(String s){
     jLabel1.setText(s);
  }
  private String getStatus(){
     return jLabel1.getText();
  }

  private void setActive(boolean on){
    jButton1.setEnabled(on);
    jButton2.setEnabled(on);
    jButton3.setEnabled(on);
    jButton4.setEnabled(on);
    jButton5.setEnabled(on);
  }
  public static void main(String[] args) {
      XServices obj = new XServices();//"DBridge Services");
      obj.setSize(400,320);
      obj.setName("Services");
      obj.setVisible(true);
      //obj.setVisible(true);
    }

   private void shutdown(int time) {
       // Schutdown in time ms
       this.setStatus(mStatusStop);

       // Shutdown the Server by sending stop command and close the application
       String stopMsg = mLabelStopMsg1; //Do you really want to schutdown the server?
       if( JOptionPane.showConfirmDialog(this,stopMsg, mLabelTitle1,JOptionPane.YES_NO_OPTION)==0 ){
         String answer=DBridgeClient.sendRequest("STOP$"+time);
         if (answer.compareTo("Bad Command")==0 ){
           //JOptionPane msgbox=new JOptionPane();
           String stopMsg2 = mLabelStopMsg2;
           JOptionPane.showMessageDialog(null, stopMsg2);
         } else {
        	 DBridgeClient.deleteLock();
        	 System.exit(1); // close the client
         }
       }
  }// end shutdown


  void jButton1_actionPerformed(ActionEvent e) {
//System.out.println("Start services");
    if ( mStatusRun.compareTo( this.getStatus() )!=0 ){
      // Start
      this.setStatus(mStatusRun);
      String answer=DBridgeClient.sendRequest("STARTDAEMONS");
         if (answer.compareTo("Bad Command")==0 ){
           //JOptionPane msgbox=new JOptionPane();
           String stopMsg = "Bad Start";
           JOptionPane.showMessageDialog(null, stopMsg);
         }
    }
  }

  void jButton2_actionPerformed(ActionEvent e) {
    // Restart Services
    String answer=DBridgeClient.sendRequest("DBRESTART");
     if (answer.compareTo("Bad Command")==0 ){
       //JOptionPane msgbox=new JOptionPane();
       String stopMsg = "Bad Restart";
       JOptionPane.showMessageDialog(null, stopMsg);
     }
    // Start Status
    this.setStatus(mStatusRun);
  }

  void jTextField1_actionPerformed(ActionEvent e) {
    // TODO check admin pasword here
    if ( (DBridgeClient.Bank()).getUserContainer().isPassValid("admin",new String(jTextField1.getPassword() ))){
      this.setActive(true);
      jTextField1.setText("");
    } else System.out.println("Wrong login");
  }

  void jButton3_actionPerformed(ActionEvent e) {
    // Stop Services
    String answer=DBridgeClient.sendRequest("STOPDAEMONS");
         if (answer.compareTo("Bad Command")==0 ){
           //JOptionPane msgbox=new JOptionPane();
           String stopMsg = "Bad Stop";
           JOptionPane.showMessageDialog(null, stopMsg);
         }
    // Stop Status
    this.setStatus(mStatusStop);
  }

  void jButton4_actionPerformed(ActionEvent e) {
    // Schutdown now
    shutdown(0);
  }

  void jButton5_actionPerformed(ActionEvent e) {
    // Schutdown when ready
    shutdown(60000);
  }

  /*****************************************************************************
   * Internationalization
   ****************************************************************************/
  void setLocale(){
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.XServicesLabelsBundle", currentLocale);
    mLabelTitleBorder1 = labels.getString("TitleBorder1");
    mLabelTitleBorder2 = labels.getString("TitleBorder2");
    mLabelTitleBorder3 = labels.getString("TitleBorder3");
    mLabelTitleBorder4 = labels.getString("TitleBorder4");
    mLabelTitleBorder5 = labels.getString("TitleBorder5");

    mLabelButton1 = labels.getString("Button1");
    mLabelButton2 = labels.getString("Button2");
    mLabelButton3 = labels.getString("Button3");
    mLabelButton4 = labels.getString("Button4");
    mLabelButton5 = labels.getString("Button5");
    mStatusRun = labels.getString("StatusRun");
    mStatusStop = labels.getString("StatusStop");
    mLabelLabel3 = labels.getString("Label3");

    mLabelStopMsg1 = labels.getString("StopMsg1");
    mLabelStopMsg2 = labels.getString("StopMsg2");

    mLabelTitle1 = labels.getString("Title1");
  }

}// end class XServices

class XServices_jButton1_actionAdapter implements java.awt.event.ActionListener {
  XServices adaptee;

  XServices_jButton1_actionAdapter(XServices adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class XServices_jButton2_actionAdapter implements java.awt.event.ActionListener {
  XServices adaptee;

  XServices_jButton2_actionAdapter(XServices adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class XServices_jTextField1_actionAdapter implements java.awt.event.ActionListener {
  XServices adaptee;

  XServices_jTextField1_actionAdapter(XServices adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jTextField1_actionPerformed(e);
  }
}

