package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */
 //imterface java.lang.*

 /*
 * Created 21.09.2003
 * Modified 5.03.04
 * Modified 24.09.07 Reason: add a possibility for an admin to setup the From Address manually,
 * to support features like fetchmail and etc.
 */
public class dbSmtpRecord implements java.io.Serializable {
  String mIP;
  String mLogin;
  String mPassword;
  int    mPort;
  boolean mSSL_flag;     // true if SSL
  String mComments;
  String mFrom;
  String mReplayTo;

  public dbSmtpRecord(String ip, String l, String p, String c) {
    Init(ip, l, p, c);
  }

  //copy constructor
  public dbSmtpRecord (dbSmtpRecord obj){
    mIP       = obj.getIP();
    mLogin    = obj.getLogin();
    mPassword = obj.getPassword();
    mPort     = obj.getPort();
    mSSL_flag = obj.isSSL();
    mComments = obj.getComments();
    mFrom     = obj.getFrom();
    mReplayTo = obj.getReplayTo();
  }

  private void Init(String ip, String l, String p, String c){
    mIP        = ip;
    mLogin     = l;
    mPassword  = p;
    mComments  = c;
    mPort      = 465;
    mSSL_flag  = true;
    mFrom      = "";  // empty field means the same address as user@server is used
    mReplayTo  = "";  // empty field means the same address as the server has
  }

  // set/get methods
  public void setIP(String ip){ mIP=ip;}
  public String getIP(){ return mIP;}
  public void setLogin(String l){ mLogin=l;}
  public String getLogin(){ return mLogin;}
  public void setPassword(String p){ mPassword=p;}
  public String getPassword(){ return mPassword;}
  public void setCommants(String c){ mComments=c;}
  public String getComments(){ return mComments;}
  public void setPort(int iPort) {mPort = iPort;}
  public int getPort() {return mPort;}
  public void setSSL(boolean flag) {mSSL_flag = flag;}
  public boolean isSSL() {return mSSL_flag;}
  // OOO 16.02.06
  public void setReplayTo(String addr) {mReplayTo = addr;}
  public String getReplayTo() {return mReplayTo;}
  //OOO 24.09.07
  public void setFrom(String addr) {mFrom = addr;}
  public String getFrom() {return mFrom;}

  public String toString() {return mIP;}

  // OOO 05.03.04
  public boolean isEqual( dbSmtpRecord other){
    if ( mIP.compareTo(other.getIP())==0 &&
         mPort==other.getPort() &&
         mLogin.compareTo(other.getLogin())==0)
         return true;
    else
         return false;
  }

  // DEBUG Methods
  public void print(){
    System.out.println("********** SMTP Record: ***********");
    System.out.println("IP="+mIP);
    System.out.println("Port="+mPort);
    System.out.println("Login="+mLogin);
    System.out.println("Password="+"********");
    System.out.println("Comments="+mComments);
    System.out.println("From="+mFrom);
    System.out.println("ReplayTo="+mReplayTo);
  }
  public static void main(String[] args) {
    dbSmtpRecord dbSmtpRecord1 = new dbSmtpRecord("mail.de","user1","userpasswd","test user 1");
    dbSmtpRecord1.print();
  }
}
