package dbridge;

import java.util.*;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 */

 /*
 * Created: 6.03.04
 */

 // The goal of this class is to track a version number of the software and
 // the lical databases.
 // XX.YY.ZZZ
 // XX - main version of the software
 // YY - modification number
 // ZZZ - Database number

 public class dbVersion implements java.io.Serializable{
  dbVersion(String ver){
     this.setVersion(ver);
  };
  dbVersion(int v1, int v2, int v3){
     Init(v1, v2, v3);
  };
  dbVersion(dbVersion v){
     Init(v.getMainVersionN(), v.getModificationN(), v.getDataBaseN());
  };


  //
  // SET/GET Methods
  //
  String getVersion(){
    return Integer.toString(mMainVersionN)+"."+Integer.toString(mModificationN)+"."+Integer.toString(mDataBaseN);
  }
  public void setVersion(String ver){
     StringTokenizer token=new StringTokenizer(ver,".");
     int v1=0;
     int v2=0;
     int v3=0;
            int pos=ver.indexOf(".");
            if ( pos>0 ){ // indicates existance of "."
                String val = new String(token.nextToken());
                if ( val!=null ){
                  v1=Integer.valueOf(val).intValue();
                  if ( token.hasMoreTokens()) {
                    val =  new String(token.nextToken());
                    v2=Integer.valueOf(val).intValue();
                    if ( token.hasMoreTokens()) {
                       val =  new String(token.nextToken());
                       v3=Integer.valueOf(val).intValue();
                    }
                  }
                }
            }
     Init(v1,v2,v3);
  };
  public int getMainVersionN(){ return mMainVersionN;};
  public int getModificationN(){return mModificationN;};
  public int getDataBaseN(){return mDataBaseN;};

 // DEBUG //
  public static void main(String[] args) {
     dbVersion ver=new dbVersion(1,0,23);
     System.out.println("Version: "+ver.getVersion());
     ver.setVersion("1.03.005");
     System.out.println("Version: "+ver.getVersion());
  }

  private int mMainVersionN;
  private int mModificationN;
  private int mDataBaseN;

  private void Init(int v1, int v2, int v3){
    mMainVersionN=v1;
    mModificationN=v2;
    mDataBaseN=v3;
  }
}
