package dbridge;


import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

/*
* Created:
* Modified 25.01.04
* Modifies 5.03.04
*/


public class dsAutoUserPanel extends JDialog{

   // Data to be entered
  dbUser mUser=new dbUser(); //instance object
  dbUser ref_User = null;    // reference object


  UserContainer mUContainer = null;
  //EncryptDecryptGPGWrapper
//24.08  GpgWrapper mWrapper= null;  // IMPORTANT to inizialize this field
  dbBank mBank= null;  // IMPORTANT to inizialize this field
  boolean mEditUser;   // true if edit/ false if new user

  boolean mOk=false;
  boolean mManSel = false;

  JTextField jUserField = new JTextField();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel_username = new JPanel();
  JLabel jNameLbl = new JLabel();
  JPanel jPanel2 = new JPanel();
  JButton jOkBttn = new JButton();
  JButton jCancelBttn = new JButton();
  FlowLayout flowLayout5 = new FlowLayout();
  JPanel jPanel_buttons = new JPanel();
  JTextField jAddrField1 = new JTextField();
  JLabel jAddrLbl1 = new JLabel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField jtfTimeout = new JTextField();
  FlowLayout flowLayout1 = new FlowLayout();
  JTextField jKeyField = new JTextField();
  JButton jPKeyBttn = new JButton();
  JLabel jlManUser = new JLabel();
  JButton jbSelManUser = new JButton();
  JLabel jlServer = new JLabel();
  FlowLayout flowLayout2 = new FlowLayout();
  JPanel jPanel5 = new JPanel();
  FlowLayout flowLayout3 = new FlowLayout();
  Box box1;
  BorderLayout borderLayout2 = new BorderLayout();
  Box box2;
  BorderLayout borderLayout3 = new BorderLayout();
  FlowLayout flowLayout4 = new FlowLayout();
  Box box3;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  FlowLayout flowLayout6 = new FlowLayout();
  ResourceBundle mLbls = ResourceBundle.getBundle(
                                            "dbridge.prop.dsAutoUserPanel",
                                            BridgeApp.getCurrentLocale());

//-------------------------------------------------------------------
  public dsAutoUserPanel(JFrame parent, boolean modal) {
  super(parent, modal);
    mUser=new dbUser();
    mEditUser=false;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
 //----------------------------------------------------------------
  public dsAutoUserPanel(JFrame parent, boolean modal,
                          UserContainer container) {
  super(parent, modal);
    mUser=new dbUser();
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    this.mUContainer = container;
  }
 //----------------------------------------------------------------
 public void setUserContainer (UserContainer container){
    this.mUContainer = container;
 }
//-----------------------------------------------------------------
 public void setBank(dbBank bank){
    mBank=bank;
    if (bank!=null)
      mUContainer = mBank.getUserContainer();
  }
//------------------------------------------------------------------
  private void jbInit() throws Exception {

    ResourceBundle mLbls = ResourceBundle.getBundle(
                                            "dbridge.prop.dsAutoUserPanel",
								                             BridgeApp.getCurrentLocale());

    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(420, 282));
    this.setTitle(mLbls.getString("Title"));

    box3 = Box.createVerticalBox();
    this.getContentPane().add(box3, BorderLayout.CENTER);
    box3.add(jPanel_username, null);
    box3.add(jPanel3, null);

    box1 = Box.createVerticalBox();
    box1.add(jPanel5, null);
    box1.add(jPanel4, null);
    box1.add(jPanel6, null);

    box2 = Box.createVerticalBox();
    jbSelManUser.setPreferredSize(new Dimension(130, 25));


    jPanel4.setLayout(flowLayout1);
    jLabel1.setMinimumSize(new Dimension(130, 25));
    jLabel1.setPreferredSize(new Dimension(130, 25));
    jLabel1.setText(mLbls.getString("TimeOut")+" ");
    jPanel4.setMinimumSize(new Dimension(1, 30));
    jPanel4.setPreferredSize(new Dimension(1, 30));
    jtfTimeout.setMinimumSize(new Dimension(40, 25));
    jtfTimeout.setPreferredSize(new Dimension(40, 25));
    jtfTimeout.setText("10");

    flowLayout1.setAlignment(FlowLayout.LEFT);
    jKeyField.setMinimumSize(new Dimension(260, 25));
    jKeyField.setPreferredSize(new Dimension(260, 25));
    jKeyField.setToolTipText("");
    jPKeyBttn.setMinimumSize(new Dimension(130, 25));
    jPKeyBttn.setPreferredSize(new Dimension(130, 25));
    jPKeyBttn.setMargin(new Insets(0, 0, 0, 0));
    jPKeyBttn.setText(mLbls.getString("PublicKey"));
    jPKeyBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jPKeyBttn_actionPerformed(e);
      }
    });

    jlManUser.setBorder(BorderFactory.createLoweredBevelBorder());
    jlManUser.setMinimumSize(new Dimension(100, 25));
    jlManUser.setPreferredSize(new Dimension(100, 25));
    jlManUser.setText(mLbls.getString("noSelection"));
    jbSelManUser.setMinimumSize(new Dimension(130, 25));
    jbSelManUser.setMargin(new Insets(0, 0, 0, 0));
    jbSelManUser.setText(mLbls.getString("MasterUser"));
    jbSelManUser.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbSelManUser_actionPerformed(e);
      }
    });
    jlServer.setBorder(BorderFactory.createLoweredBevelBorder());
    jlServer.setMinimumSize(new Dimension(150, 25));
    jlServer.setPreferredSize(new Dimension(150, 25));
    jlServer.setText(mLbls.getString("noServer"));
    flowLayout2.setAlignment(FlowLayout.LEFT);
    jPanel5.setLayout(flowLayout3);
    jAddrField1.setMinimumSize(new Dimension(260, 25));
    jAddrField1.setPreferredSize(new Dimension(260, 25));
    flowLayout3.setAlignment(FlowLayout.LEFT);
    flowLayout4.setAlignment(FlowLayout.LEFT);

    jPanel1.setLayout(flowLayout4);
    jPanel1.setPreferredSize(new Dimension(142, 30));
    jPanel1.setMinimumSize(new Dimension(142, 30));

    jUserField.setPreferredSize(new Dimension(200, 25));
    jUserField.setMinimumSize(new Dimension(200, 25));
    jPanel_username.setLayout(borderLayout3);
    jPanel_username.setBorder(BorderFactory.createEtchedBorder());
    jPanel_username.setMinimumSize(new Dimension(146, 60));
    jPanel_username.setPreferredSize(new Dimension(146, 60));

    jNameLbl.setMinimumSize(new Dimension(130, 25));
    jNameLbl.setPreferredSize(new Dimension(130, 25));
    jNameLbl.setHorizontalTextPosition(SwingConstants.RIGHT);
    jNameLbl.setText(mLbls.getString("UserLogin"));
    jPanel2.setLayout(flowLayout2);
    jPanel2.setMinimumSize(new Dimension(140, 30));
    jPanel2.setPreferredSize(new Dimension(382, 30));

    jOkBttn.setText(mLbls.getString("Apply"));
    jOkBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jOkBttn_actionPerformed(e);
      }
    });
    jCancelBttn.setText(mLbls.getString("Cancel"));
    jCancelBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCancelBttn_actionPerformed(e);
      }
    });
    jPanel_buttons.setBorder(BorderFactory.createEtchedBorder());
    jPanel_buttons.setLayout(flowLayout5);
    jAddrLbl1.setText(mLbls.getString("RecipientAddress"));
    jAddrLbl1.setMinimumSize(new Dimension(130, 25));
    jAddrLbl1.setPreferredSize(new Dimension(130, 25));
    jAddrLbl1.setToolTipText("");

    jPanel3.setPreferredSize(new Dimension(146, 70));
    jPanel3.setMinimumSize(new Dimension(146, 40));
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setLayout(borderLayout2);
    jPanel3.add(box1, BorderLayout.CENTER);

    jPanel6.setLayout(flowLayout6);
    flowLayout6.setAlignment(FlowLayout.LEFT);
    jPanel1.add(jNameLbl, null);
    jPanel1.add(jUserField, null);


    jPanel_username.add(box2, BorderLayout.CENTER);


    jPanel_buttons.add(jOkBttn, null);
    jPanel_buttons.add(jCancelBttn, null);
    jPanel2.add(jbSelManUser, null);
    jPanel2.add(jlManUser, null);
    jPanel2.add(jlServer, null);


    box2.add(jPanel1, null);
    box2.add(jPanel2, null);


    jPanel4.add(jPKeyBttn, null);
    jPanel4.add(jKeyField, null);
    jPanel5.add(jAddrLbl1, null);
    jPanel5.add(jAddrField1, null);

    jPanel6.add(jLabel1, null);
    jPanel6.add(jtfTimeout, null);


    this.getContentPane().add(jPanel_buttons, BorderLayout.SOUTH);

  }

  //-----------------------------------------------------------------------

  void jOkBttn_actionPerformed(ActionEvent e) {
    if (this.checkErrors()){
    this.fillFields();
    // set ok flag
    this.mOk=true;
    this.setVisible(false);
    }
  }
  //----------------------------------------------------------------------
  void jCancelBttn_actionPerformed(ActionEvent e) {
    this.mOk = false;
    this.setVisible(false);
  }
  //-----------------------------------------------------------------------
  private void fillFields(){
    mUser.setID( 1000); //automatic type TODO: change latter to unique ID
    mUser.setLogin(this.jUserField.getText());
    dbMailRecord recipient = new dbMailRecord();
    recipient.setMail(jAddrField1.getText());
    recipient.setTimeDelay(Integer.parseInt(jtfTimeout.getText()));
    recipient.setPubKeyN(jKeyField.getText());
    dbMailTable table = new dbMailTable();
    table.append(recipient);
    mUser.setAddressBook(table);
  }
  //-----------------------------------------------------------------------
  private void writeFields(){

    this.jUserField.setText(mUser.getLogin());
    dbMailRecord recipient = mUser.getAddressBook().getRecord(0);
    jAddrField1.setText(recipient.getMail());
    jtfTimeout.setText(Integer.toString(recipient.getTimeDelay()));
    jKeyField.setText(recipient.getPubKeyN());
    this.jlManUser.setText(mUser.getName());
    this.jlServer.setText(mUser.getSmtpTable().getRecord(0).getIP());
  }


  //-----------------------------------------------------------------
  void jPKeyBttn_actionPerformed(ActionEvent e) {
  /*  Vector lines=new Vector();
    //EncryptDecryptGPGWrapper mywrapper = new EncryptDecryptGPGWrapper(BridgeApp.Bank().getBox().getGpgPath());
    GpgWrapper mywrapper = BridgeApp.Bank().getGPGWrapper();//new GpgWrapper(BridgeApp.Bank().getBox().getGpgPath()); Andrei: Why do not use BridgeApp.Bank().getGPGWrapper()?
      if ( mBank!=null) {
        try {  lines = mywrapper.getKeys(false);  //mywrap.getIDs();
            } catch (Exception exp) {
                BridgeApp.Log.println(" GPGWrapper does not work properly: getIds failed ");
            }
       } //end if
          xKeyDialog obj=new xKeyDialog(this,"Setting Key ID\n",true);
          obj.setLines(lines);
          obj.setVisible(true);

          // take key id
          String result=obj.getKeyN();
          if ( result.compareTo("")!=0 ){ // if not cancel
              jKeyField.setText(result);
           }
      }
     */
    dsGPGKeyDialog gpg = new dsGPGKeyDialog(null, true);
    gpg.setVisible(true);
    if (gpg.isOk()){
      jKeyField.setText(gpg.getSelectedKey());
    }
    gpg.dispose();

  }
  //---------------------------------------------------------------------
  private boolean checkErrors()
  {
    if ( mEditUser==false ){
      if (mBank.getUserContainer().isLoginValid(this.jUserField.getText())==false ){
        this.jUserField.setText("");
        //JOptionPane msgbox=new JOptionPane();
        //msgbox
        JOptionPane.showMessageDialog(null, mLbls.getString("userNotUniq"));
        return false;
      }
    }
    //Veryfy the address
    if (jAddrField1.getText().length()<2){
       JOptionPane.showMessageDialog(null, mLbls.getString("noAddr"), mLbls.getString("Error"), 1);
       return false;
    }

    if (!this.mManSel){
      JOptionPane.showMessageDialog(null, mLbls.getString("noMaster"), mLbls.getString("Error"), 1);
      return false;
    }

    if (Integer.parseInt(this.jtfTimeout.getText())<1){
      JOptionPane.showMessageDialog(null, mLbls.getString("badTimeOut"), mLbls.getString("Error"), 1);
      return false;
    }

    if (jKeyField.getText().length()<1){
       JOptionPane.showMessageDialog(null, mLbls.getString("noPubKey"), mLbls.getString("Error"), 1);
       return false;
    }

    return true;
  }
  //--------------------------------------------------------------------------
  public dbUser getUser(){
    ref_User.copy(mUser);
    return ref_User;
  }
  //------------------------------------------------------------------------
  public void setUser(dbUser user){
    mUser= new dbUser(user);
    ref_User = user;

    writeFields();

   }
  //-------------------------------------------------------------------
  public void setEditMode(){
    mEditUser=true;
    jUserField.setEnabled(false);
    this.mManSel = true;
  }
  //-------------------------------------------------------------------------
  public boolean isOk(){
    return mOk;
  }
  //----------------------------------------------------------------------
  public static void main(String[] args) {
    dsAutoUserPanel dsAutoUserPanel1 = new dsAutoUserPanel(null, false);
    dsAutoUserPanel1.setVisible(true);
  }
  //-------------------------------------------------------------------------
  void jbSelManUser_actionPerformed(ActionEvent e) {
    if (mUContainer != null){
      if (mUContainer.size>0){
        dsSelUserListDlg dlg = new dsSelUserListDlg(null, true,
                              this.mUContainer);
        dlg.setVisible(true);
        if (dlg.isOk()){
          // copy a Smtp record from a Master to the autouser
          String uname = dlg.getSelectedUser();
          dbSmtpRecord rec = mUContainer.getUser(uname).getSmtpTable().getRecord(dlg.getSelectedSrvNum());
          dbSmtpTable table = new dbSmtpTable();
          table.append(rec);
          // copy a Mail record from a dialog to the autouser
          dbMailRecord mrec = mUContainer.getUser(uname).getMailTable().getRecord(0);
          dbMailTable mtable = new dbMailTable();
          mtable.append(mrec);

          //update database
          this.mUser.setName(uname);
          this.mUser.setSmtpTable(table);
          this.mUser.setMailTable(mtable);
          this.mUser.setSmtpDefaultN(0);



          //update interface labels
          this.jlManUser.setText(uname);
          this.jlServer.setText(rec.getIP());

          //update complete verification variable
          this.mManSel = true;
         }
      }
    }
    else{
      mManSel = false;
      BridgeApp.LogError(Logs.Srvcs.SetText("ERROR: NULL pointer to UserContainer!!! (Selection a user)"));
    }
  }
 //-------------------------------------------------------------------
}
