package dbridge;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

public class dsDcmServDlg extends JDialog {

  dsDcmServerClass DcmServer = new dsDcmServerClass();
  boolean Created = false;
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField tfIP = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField tfPort = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField tfAeT = new JTextField();
  JLabel jLabel4 = new JLabel();
  JTextField tfComments = new JTextField();
  JButton bOk = new JButton();
  JButton bCancel = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout1 = new BorderLayout();

  public dsDcmServDlg(JFrame parent, boolean modal) {
    super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(388, 197));
    this.addComponentListener(new java.awt.event.ComponentAdapter() {
      public void componentShown(ComponentEvent e) {
        this_componentShown(e);
      }
    });
    this.setTitle("Dicom Server Settings");
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setMinimumSize(new Dimension(200, 20));
    jPanel1.setPreferredSize(new Dimension(200, 60));
    jPanel1.setLayout(null);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setMinimumSize(new Dimension(200, 40));
    jPanel2.setPreferredSize(new Dimension(200, 60));
    jPanel2.setLayout(null);
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setLayout(flowLayout1);
    jLabel1.setText("Server IP address:");
    jLabel1.setBounds(new Rectangle(9, 5, 107, 17));
    tfIP.setBounds(new Rectangle(9, 25, 159, 21));
    jLabel2.setText("Server port:");
    jLabel2.setBounds(new Rectangle(174, 5, 70, 17));
    tfPort.setBounds(new Rectangle(174, 25, 82, 21));
    jLabel3.setText("AeTitle:");
    jLabel3.setBounds(new Rectangle(262, 5, 56, 17));
    tfAeT.setBounds(new Rectangle(262, 25, 105, 21));
    jLabel4.setText("Comments:");
    jLabel4.setBounds(new Rectangle(7, 5, 82, 17));
    tfComments.setBounds(new Rectangle(7, 27, 365, 21));
    bOk.setText("Ok");
    bOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bOk_actionPerformed(e);
      }
    });
    bCancel.setText("Cancel");
    bCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bCancel_actionPerformed(e);
      }
    });
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jLabel1, null);
    jPanel1.add(tfIP, null);
    jPanel1.add(tfPort, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(tfAeT, null);
    jPanel1.add(jLabel3, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jLabel4, null);
    jPanel2.add(tfComments, null);
    this.getContentPane().add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(bOk, null);
    jPanel3.add(bCancel, null);
  }

  void bOk_actionPerformed(ActionEvent e) {
      if (tfIP.getText().equals("")) {
       JOptionPane.showMessageDialog(this, "Please specify the Server IP!");
       return;}
      if (tfPort.getText().equals("")) {
       JOptionPane.showMessageDialog(this, "Please specify the Port!");
       return;}
      if (tfAeT.getText().equals("")) {
       JOptionPane.showMessageDialog(this, "Please specify the AeTitle!");
       return;}

      this.DcmServer.setDcmServer(tfIP.getText());
      this.DcmServer.setDcmPort(tfPort.getText());
      this.DcmServer.setDcmAeTitle(tfAeT.getText());
      this.DcmServer.setComments(tfComments.getText());
      Created = true;
      this.setVisible(false);
  }

  void bCancel_actionPerformed(ActionEvent e) {
      Created = false;
      this.setVisible(false);
  }

  public void setDcmServer (dsDcmServerClass serv){
      DcmServer = serv;
  }

  dsDcmServerClass getDcmServer () {
        return DcmServer;
  }

  public boolean IsCreated () {
        return Created;
  }

  void this_componentShown(ComponentEvent e) {

      tfIP.setText(DcmServer.getDcmServer());
      tfPort.setText(DcmServer.getDcmPort());
      tfAeT.setText(DcmServer.getDcmAeTitle());
      tfComments.setText(DcmServer.getComments());
      Created = false;

  }

//-- DEBUG
  public static void main(String[] args) {
    dsDcmServDlg dlg = new dsDcmServDlg(null, true);
    dlg.setVisible(true);

  }

}
