package dbridge;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author Aleh
 * @version 1.0
 */

public class dsSelUserListDlg extends JDialog {

  boolean mOk=false;
  Vector users;
  Vector servers = new Vector();
  UserContainer mContainer;
  String mName;
  int mServer;


  //------------------------------------------------------------------------
  JPanel jPanel2 = new JPanel();
  JButton jbOk = new JButton();
  JButton jbCancel = new JButton();
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  Box box1;
  JPanel jPanel1 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jlUsers = new JList();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList jlservers = new JList();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  BorderLayout borderLayout3 = new BorderLayout();
  //----------------------------------------------------------------------
  public dsSelUserListDlg(JFrame parent, boolean modal) {
  super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //-----------------------------------------------------------------------
  public dsSelUserListDlg(JFrame parent, boolean modal, UserContainer C) {
  super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    if (C.size>0){
      this.mContainer = C;
      this.users = C.getManualUserList();
      this.jlUsers.setListData(this.users);
      this.jlUsers.setSelectedIndex(0);
      this.newUserSelected();
    }
  }
  //-----------------------------------------------------------------------
  public void setUsers (UserContainer C){
    if (C.size>0){
      this.mContainer = C;
      this.users = C.getManualUserList();
      this.jlUsers.setListData(this.users);
      this.jlUsers.setSelectedIndex(0);
      this.newUserSelected();
    }
  }
  //---------------------------------------------------------------------
  public String getSelectedUser(){
    return this.mName;
  }
  //------------------------------------------------------------------------
  public int getSelectedSrvNum(){
    return this.mServer;
  }
  //------------------------------------------------------------------------
  public boolean isOk(){
    return mOk;
  }
  //-----------------------------------------------------------------------

  //-------------------------------------------------------------------------
  private void jbInit() throws Exception {

    box1 = Box.createHorizontalBox();
    this.getContentPane().setLayout(borderLayout2);
    this.setSize(new Dimension(386, 250));
    this.setTitle("Select User");
    this.setResizable(true);

    jPanel2.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel2.setLayout(flowLayout1);
    jbOk.setText("Ok");
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });
    jbCancel.setText("Cancel");
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });
    jlUsers.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jlUsers.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jlUsers_mouseClicked(e);
      }
    });
    jlservers.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jlservers_mouseClicked(e);
      }
    });
    jPanel3.setLayout(borderLayout1);
    jPanel1.setLayout(borderLayout3);
    jLabel1.setText("Manual User Name:");
    jLabel2.setText("Select SMTP Server:");
    jPanel1.setBorder(BorderFactory.createRaisedBevelBorder());
    jPanel3.setBorder(BorderFactory.createRaisedBevelBorder());
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jbOk, null);
    jPanel2.add(jbCancel, null);
    this.getContentPane().add(box1,  BorderLayout.CENTER);
    box1.add(jPanel3, null);
    jPanel3.add(jScrollPane1, BorderLayout.CENTER);
    jPanel3.add(jLabel1, BorderLayout.NORTH);
    //jScrollPane1.add(jlUsers, null);
    jScrollPane1.getViewport().add(jlUsers, null);
    box1.add(jPanel1, null);
    jPanel1.add(jScrollPane2, BorderLayout.CENTER);
    jPanel1.add(jLabel2,  BorderLayout.NORTH);
    //jScrollPane2.add(jlservers, null);
    jScrollPane2.getViewport().add(jlservers, null);

  }
  //----------------------------------------------------------------------
  void jbOk_actionPerformed(ActionEvent e) {
    //this.mOk = true;
    this.setVisible(false);
  }
  //-------------------------------------------------------------------------
  void jbCancel_actionPerformed(ActionEvent e) {
    this.mOk = false;
    this.setVisible(false);
  }
  //----------------DEBUG-------------------------------------------------
    public static void main(String[] args) {
    dsSelUserListDlg dsSelUserListDlg1 = new dsSelUserListDlg(null, true);
    UserContainer a = new UserContainer();
    dsSelUserListDlg1.setUsers(a);
    dsSelUserListDlg1.setVisible(true);
  }
  //------------------------------------------------------------------------
  void jlUsers_mouseClicked(MouseEvent e) {
      this.newUserSelected();
  }
  //------------------------------------------------------------------------
  void jlservers_mouseClicked(MouseEvent e) {
      this.newSrvSelected();
  }
  //--------------------------------------------------------------------------
  void newUserSelected (){
      if (users != null){
        if (users.size()>0){
         this.mName = (String) this.jlUsers.getSelectedValue();

         int lSize = this.mContainer.getUser(this.mName).getSmtpTable().getSize();
         servers.clear();
         for (int i=0; i<lSize; i++){
            String curr = this.mContainer.getUser(this.mName).
                          getSmtpTable().getRecord(i).getIP();
            this.servers.add(curr);
          }
          if (servers != null){
            if (servers.size()>0){
              this.jlservers.setListData(this.servers);
              this.jlservers.setSelectedIndex(0);
              this.newSrvSelected();
              this.mOk = true;
          }
          }
        }else{this.mOk = false;}
      }else{
        this.mOk = false;
      }
  }
  //-------------------------------------------------------------------------
  void newSrvSelected(){
    if (this.servers !=null)
    if (this.servers.size()>0){
      this.mServer = this.jlservers.getSelectedIndex();
    }
  }
 //--------------------------------------------------------------------------


}