package dbridge;

import java.util.Locale;
import java.util.ResourceBundle;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class dsServerCheckerDlg extends JDialog {
  private ResourceBundle lbls;


  public dsServerCheckerDlg() throws HeadlessException {
    Locale currentLocale = BridgeApp.getCurrentLocale();

  //  Locale currentLocale = new Locale("de");
    lbls = ResourceBundle.getBundle(
        "dbridge.prop.dsServerCheckerDlgBundle",
        currentLocale);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setSize(new Dimension(320, 200));
    this.setTitle(lbls.getString("chk"));
    JPanel pane1 = new JPanel();
    JPanel pane2 = new JPanel();

    Component component1=Box.createVerticalStrut(8);
    pane1.add(component1);
    JLabel label1=new JLabel();
    Dimension labdim=new Dimension(200,27);
    label1.setText(lbls.getString("con"));
    label1.setMaximumSize(labdim);
    label1.setMinimumSize(labdim);
    label1.setPreferredSize(labdim);
    label1.setIcon(new ImageIcon("./lib/res/world2.png"));

    pane1.add(label1);
    JButton bClose = new JButton();
    bClose.setText(lbls.getString("bClose"));
    bClose.setIcon(new ImageIcon("./lib/res/thumbdown.gif"));
    bClose.addActionListener(new dsServerCheckerDlg_bClose_actionAdapter(this));
    pane2.add(bClose);

    this.getContentPane().add(pane1, BorderLayout.CENTER);
    this.getContentPane().add(pane2, BorderLayout.SOUTH);
  }

  void bClose_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }

  public static void main(String[] args) throws HeadlessException {
  dsServerCheckerDlg dsSelFilesDlg1 = new dsServerCheckerDlg();
  dsSelFilesDlg1.setVisible(true);
}



}

class dsServerCheckerDlg_bClose_actionAdapter implements java.awt.event.ActionListener {
  dsServerCheckerDlg adaptee;

  dsServerCheckerDlg_bClose_actionAdapter(dsServerCheckerDlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.bClose_actionPerformed(e);
  }
}
