package dbridge;



import javax.swing.JDialog;

import java.awt.HeadlessException;

import java.awt.Frame;

import java.awt.*;

import javax.swing.*;

import java.util.*;

import javax.swing.border.*;

import java.awt.event.*;



/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

/*
* Created 7.11.04 BOB
* Modified 10.11.04 BOB
* Modified 15.04.05
* Modified 18.06.05
* Modified 28.08.06
*/

public class dsUserLoginDlg extends JDialog {
  private boolean AUTO = true;
  private boolean mOk = false;
  private UserController mForm = null;

  ResourceBundle lbls;
  BorderLayout borderLayout1 = new BorderLayout();
  Box mBox;

  JPanel jpUserType = new JPanel();
  JPanel jpButtons = new JPanel();
  JButton jbOk = new JButton();
  JButton jbCancel = new JButton();
  JRadioButton jrb_automatic = new JRadioButton();
  JRadioButton jrb_manual = new JRadioButton();
  ButtonGroup buttonGroup1 = new ButtonGroup();

  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JPanel jpLogin = new JPanel();
  JLabel jlLogin = new JLabel();
  JTextField tfLogin;

  public dsUserLoginDlg(Frame parent, ResourceBundle labels, boolean modal) {
    super(parent, modal);
    //
    //perhaps not correct
    mForm = (UserController) parent;
    lbls = labels;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    if (mForm.getUserContainer().getManualUserList().size() < 1) {
      jrb_automatic.setEnabled(false);
      jrb_manual.setSelected(true);
      AUTO = false;
    }
  }

  public void setCopyMode(dbUser user){
    jpUserType.setVisible(false);
    int uID = user.getID();
    if (uID>99 && uID<999){
      AUTO = false;
    }else{
      AUTO = true;
    }
    tfLogin.setText(new String(user.getLogin()+"_copy"));
  }

  private void jbInit(){
    this.setSize(new Dimension(400, 280));
    this.setTitle(lbls.getString("LoginDlgName"));
    this.setResizable(false);

    mBox = Box.createVerticalBox();
    this.getContentPane().setLayout(borderLayout1);
    titledBorder1 = new TitledBorder(BorderFactory
                                     .createTitledBorder(lbls.getString("user_type")));
    titledBorder2 = new TitledBorder(BorderFactory
                                     .createTitledBorder(lbls.getString("login")));

    jpLogin.setBorder(titledBorder2);
    jrb_automatic.setSelected(true);
    jrb_automatic.setText(lbls.getString("auto"));
    jrb_automatic.setForeground(new Color(0.9f,0.1f,0.2f));
    jrb_automatic.setIcon(new ImageIcon("./lib/res/laptop_select.png"));
    jrb_automatic.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jrb_automatic_actionPerformed(e);
      }
    });

    jrb_manual.setText(lbls.getString("manual"));
    jrb_manual.setForeground(new Color(0.2f,0.1f,0.9f));
    jrb_manual.setIcon(new ImageIcon("./lib/res/user.png"));
    jrb_manual.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jrb_manual_actionPerformed(e);
      }
    });

    // make the login field change-validated
    LoginFieldDocument doc= new LoginFieldDocument();
    tfLogin = new JTextField(doc, null, 0);
    tfLogin.setMaximumSize(new Dimension(60000, 21));
    tfLogin.setMinimumSize(new Dimension(80, 21));
    tfLogin.setPreferredSize(new Dimension(150, 21));

    jpUserType.add(jrb_automatic);
    jpUserType.add(jrb_manual);
    jpUserType.setBorder(titledBorder1);

    buttonGroup1.add(jrb_automatic);
    buttonGroup1.add(jrb_manual);
    mBox.add(jpUserType);
    jpLogin.add(tfLogin);
    mBox.add(jpLogin);

    jpButtons.setBorder(BorderFactory.createEtchedBorder());
    jbOk.setText(lbls.getString("bOk"));
    jbOk.setIcon(new ImageIcon("./lib/res/thumbup.gif"));
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });

    jbCancel.setText(lbls.getString("bClose"));
    jbCancel.setIcon(new ImageIcon("./lib/res/thumbdown.gif"));
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });

    jpButtons.add(jbOk);
    jpButtons.add(jbCancel);
    this.getContentPane().add(mBox, BorderLayout.CENTER);
    this.getContentPane().add(jpButtons, BorderLayout.SOUTH);
  }

  public static void main(String[] args) throws HeadlessException {
    Locale currentLocale = new Locale("en");
    ResourceBundle lbls = ResourceBundle.getBundle("dbridge.prop.dsMainFormBundle",
                                    currentLocale);
    dsUserLoginDlg dsUserLoginDlg1 = new dsUserLoginDlg(null, lbls, false);
    dsUserLoginDlg1.setVisible(true);
  }

  void jrb_automatic_actionPerformed(ActionEvent e) {
      AUTO = true;
      jrb_manual.setIcon(new ImageIcon("./lib/res/user.png"));
      jrb_automatic.setIcon(new ImageIcon("./lib/res/laptop_select.png"));
      jrb_automatic.setForeground(new Color(0.9f,0.1f,0.2f));
      jrb_manual.setForeground(new Color(0.2f,0.1f,0.9f));
  }

//----------------------------------------------------------------------
  void jrb_manual_actionPerformed(ActionEvent e) {
      AUTO = false;
      jrb_manual.setIcon(new ImageIcon("./lib/res/user_select.png"));
      jrb_automatic.setIcon(new ImageIcon("./lib/res/laptop.png"));
      jrb_manual.setForeground(new Color(0.9f,0.1f,0.2f));
      jrb_automatic.setForeground(new Color(0.2f,0.1f,0.9f));
  }

  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    this.setVisible(false);
  }

  void jbOk_actionPerformed(ActionEvent e) {
    if (mForm.getUserContainer().isLoginValid(tfLogin.getText()) == false) {
      JOptionPane.showMessageDialog(null, lbls.getString("BadName"));
    } else {
      mOk = true;
      this.setVisible(false);
    }
  }

  boolean isOK() {
    return mOk;
  }

  String getLogin(){
    return this.tfLogin.getText();
  }

//------------------------------------------------------------------------
  boolean isAUTO() {
    return AUTO;
  }
}
